typedef struct _IO_STACK_LOCATION {
    UCHAR MajorFunction;

    UCHAR MinorFunction;
    UCHAR Flags;
    UCHAR Control;
    // ̃[U[p[^́CĂяoĂT[rXɊÂĂ
    // hCoуt@CVXéCW[邢̓}Ci[t@NV
    // R[hZbgČł

    union {

        //  NtCreateFile VXeT[rXp[^

        struct {
            PIO_SECURITY_CONTEXT SecurityContext;
            ULONG Options;

            USHORT POINTER_ALIGNMENT FileAttributes;
            USHORT ShareAccess;
            ULONG POINTER_ALIGNMENT EaLength;
        } Create;


        // NtReadFileVXeT[rXp[^

        struct {
            ULONG Length;
            ULONG POINTER_ALIGNMENT Key;
            LARGE_INTEGER ByteOffset;
        } Read;

        // NtWriteFileVXeT[rXp[^

        struct {
            ULONG Length;
            ULONG POINTER_ALIGNMENT Key;
            LARGE_INTEGER ByteOffset;
        } Write;


        // NtQueryInformationFileVXeT[rXp[^

        struct {
            ULONG Length;
            FILE_INFORMATION_CLASS POINTER_ALIGNMENT 
							FileInformationClass;

        } QueryFile;


        // NtSetInformationFileVXeT[rXp[^

        struct {
            ULONG Length;
            FILE_INFORMATION_CLASS POINTER_ALIGNMENT 
							FileInformationClass;
            PFILE_OBJECT FileObject;
            union {
                struct {
                    BOOLEAN ReplaceIfExists;
                    BOOLEAN AdvanceOnly;
                };
                ULONG ClusterCount;
                HANDLE DeleteHandle;
            };
        } SetFile;


        // NtQueryVolumeInformationFileVXeT[rXp[^

        struct {
            ULONG Length;
            FS_INFORMATION_CLASS POINTER_ALIGNMENT 
							FsInformationClass;
        } QueryVolume;


        // NtFlushBuffersFileVXeT[rXp[^
        // Ƀ[U[ɋꂽp[^͂Ȃ


        // NtDeviceIoControlFileVXeT[rXp[^
        // [U[̃AEgvbgobt@UserBufferłC
        // [U[̃Cvbgobt@SystemBufferł

        struct {
            ULONG OutputBufferLength;
            ULONG POINTER_ALIGNMENT InputBufferLength;
            ULONG POINTER_ALIGNMENT IoControlCode;
            PVOID Type3InputBuffer;
        } DeviceIoControl;

        // VXep[^ł͂Ȃ
        // MountVolumẽp[^

        struct {
            PVOID DoNotUse1;
            PDEVICE_OBJECT DeviceObject;
        } MountVolume;

        // VerifyVolumẽp[^

        struct {
            PVOID DoNotUse1;
            PDEVICE_OBJECT DeviceObject;
        } VerifyVolume;

        // SCSĨp[^iIRP_MJ_INTERNAL_DEVICE_CONTROLj

        struct {
            struct_SCSI_REQUEST_BLOCK *Srb;
        } Scsi;


        // IRP_MN_QUERY_DEVICE_RELATIONS̃p[^

        struct {
            DEVICE_RELATION_TYPE Type;
        } QueryDeviceRelations;

        // IRP_MN_QUERY_INTERFACẼp[^

        struct {
            CONST GUID *InterfaceType;
            USHORT Size;
            USHORT Version;
            PINTERFACE Interface;
            PVOID InterfaceSpecificData;
        } QueryInterface;


        // IRP_MN_QUERY_CAPABILITIES̃p[^

        struct {
            PDEVICE_CAPABILITIES Capabilities;
        } DeviceCapabilities;

        // IRP_MN_FILTER_RESOURCE_REQUIREMENTS̃p[^

        struct {
            PIO_RESOURCE_REQUIREMENTS_LIST 
							IoResourceRequirementList;
        } FilterResourceRequirements;

        // IRP_MN_READ_CONFIGIRP_MN_WRITE_CONFIG̃p[^

        struct {
            ULONG WhichSpace;
            PVOID Buffer;
            ULONG Offset;
            ULONG POINTER_ALIGNMENT Length;
        } ReadWriteConfig;

        // IRP_MN_SET_LOCK̃p[^

        struct {
            BOOLEAN Lock;
        } SetLock;

        // IRP_MN_QUERY_ID̃p[^

        struct {
            BUS_QUERY_ID_TYPE IdType;
        } QueryId;

        // IRP_MN_QUERY_DEVICE_TEXT̃p[^

        struct {
            DEVICE_TEXT_TYPE DeviceTextType;
            LCID POINTER_ALIGNMENT LocaleId;
        } QueryDeviceText;

        // IRP_MN_DEVICE_USAGE_NOTIFICATIOÑp[^

        struct {
            BOOLEAN InPath;
            BOOLEAN Reserved[3];
            DEVICE_USAGE_NOTIFICATION_TYPE POINTER_ALIGNMENT 
							Type;
        } UsageNotification;

        // IRP_MN_WAIT_WAKẼp[^

        struct {
            SYSTEM_POWER_STATE PowerState;
        } WaitWake;

        // IRP_MN_POWER_SEQUENCẼp[^

        struct {
            PPOWER_SEQUENCE PowerSequence;
        } PowerSequence;

        // IRP_MN_SET_POWERIRP_MN_QUERY_POWER̃p[^

        struct {
            ULONG SystemContext;
            POWER_STATE_TYPE POINTER_ALIGNMENT Type;
            POWER_STATE POINTER_ALIGNMENT State;
            POWER_ACTION POINTER_ALIGNMENT ShutdownType;
        } Power;

        // StartDevicẽp[^

        struct {
            PCM_RESOURCE_LIST AllocatedResources;
            PCM_RESOURCE_LIST AllocatedResourcesTranslated;
        } StartDevice;

        // Cleanup̃p[^
        // Ƀ[U[ɋꂽp[^͂Ȃ

        // WMI

        struct {
            ULONG_PTR ProviderId;
            PVOID DataPath;
            ULONG BufferSize;
            PVOID Buffer;
        } WMI;

        // ̑ | hCo̎dlɂ

        struct {
            PVOID Argument1;
            PVOID Argument2;
            PVOID Argument3;
            PVOID Argument4;
        } Others;

    } Parameters;

    // ̃NGXgsfoCXhCõfoCXIuWFNg
    // |C^Z[uDāCKvƂȂ΁C
    // [`ɓnƂł

    PDEVICE_OBJECT DeviceObject;

    // ȉ́Ĉ߂̃t@CIuWFNg|C^܂

    PFILE_OBJECT FileObject;

    // ̃[`́COq̃tOtB[hɂtOɉČĂяo
    PIO_COMPLETION_ROUTINE CompletionRoutine;

    // ȉ́CCompletionRoutineɒ`֐ɓnׂ
    // ReNXgp[^̃AhXXgA邽߂Ɏg

    PVOID Context;

} IO_STACK_LOCATION, *PIO_STACK_LOCATION;
