NTSTATUS USB_GetConfigurationDescriptor(
    IN PDEVICE_OBJECT DeviceObject,
    IN ULONG configurationDescriptorSize,
    IN PUSB_CONFIGURATION_DESCRIPTOR configurationDescriptor
)
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus;
    PURB urb = NULL;

    deviceExtension = DeviceObject->DeviceExtension;

    // GET_CONFIGURATION_DESCRIPTOR𔭍s邽߂URBmۂ
    urb = ExAllocatePool(NonPagedPool,
        sizeof(struct _URB_CONTROL_DESCRIPTOR_REQUEST));

    // GET_CONFIGURATION_DESCRIPTOR𔭍s邽߂URB쐬
    UsbBuildGetDescriptorRequest(urb,
        (USHORT) sizeof (struct 
							_URB_CONTROL_DESCRIPTOR_REQUEST),
        USB_CONFIGURATION_DESCRIPTOR_TYPE,
        0,
        0,
        configurationDescriptor,
        NULL,
        configurationDescriptorSize,
        NULL);

    // GET_CONFIGURATION_DESCRIPTOR𔭍s

    ntStatus = USB_CallUSBD(DeviceObject, urb);

    if (urb)
        ExFreePool(urb);

    return ntStatus;
}
