NTSTATUS USB_SelectConfiguration(
    IN PDEVICE_OBJECT                DeviceObject,
    IN PUSB_CONFIGURATION_DESCRIPTOR ConfigurationDescriptor
    )
{
    PDEVICE_EXTENSION	deviceExtension;
    NTSTATUS		ntStatus;
    PURB			urb = NULL;
    ULONG			i, dir;
    PUSB_INTERFACE_DESCRIPTOR   interfaceDescriptor;
    PUSBD_INTERFACE_INFORMATION Interface;
    PUSBD_INTERFACE_LIST_ENTRY 
					interfaceList,topOfInterfaceList;

    // SELECT_CONFIGURATION
    // ̃foCXhCo̓C^[tF[X1̃foCXT|[gĂ

    deviceExtension = DeviceObject->DeviceExtension;

    // C^[tF[XiWDMŊǗjXg擾
    // 2mۂĂ邪C2ڂ͏Ĩ}[LÔ
    topOfInterfaceList =interfaceList
        = ExAllocatePool(NonPagedPool,
							sizeof(USBD_INTERFACE_LIST_ENTRY) * 
2);
    if(!interfaceList) {
        ntStatus = STATUS_NO_MEMORY;
        goto USB_SelectInterfacesExit;
    }

    //C^[tF[XfBXNv^擾
    interfaceDescriptor =
        USBD_ParseConfigurationDescriptorEx(
            ConfigurationDescriptor,
            ConfigurationDescriptor,
            //T[`ŏ̃C^[tF[XfBXNv^
            0, 		// interface number
            -1, 		// alternate setting
            -1,   	// interface class
            -1, 		// interface subclass
            -1 ); 	// interface protocol

    // C^[tF[XXgXV
    interfaceList->InterfaceDescriptor = interfaceDescriptor;
    interfaceList->Interface = NULL;
    // C^[tF[X1ŏI
    interfaceList++;
    interfaceList->InterfaceDescriptor = NULL;
    interfaceList->Interface = NULL;

    // SelectConfiguration̂߂URBmۂāC
    // Kvȃf[^tH[}bg

    urb = USBD_CreateConfigurationRequestEx(
            ConfigurationDescriptor, topOfInterfaceList);

    // USBD_ParseConfigurationDescriptorExŐݒ肳ꂽ
    // C^[tF[XiWDMǗj擾
    Interface = &urb->UrbSelectConfiguration.Interface;

    // pCv̓]TCYCʂɑOɂ炩ߐݒ肷
    for (i = 0; i < Interface->NumberOfPipes; i++) {
        Interface->Pipes[i].MaximumTransferSize = 4096;
    }

    // ZNgRtBM[Vs
    ntStatus = USB_CallUSBD(DeviceObject, urb);

    // ZNgRtBM[V͐H
    if (NT_SUCCESS(ntStatus)) {

        // KvȏDEVICE_EXTENSION\̂ɃXgA
        deviceExtension->ConfigurationHandle =
            urb->UrbSelectConfiguration.ConfigurationHandle;
        deviceExtension->Interface =
            ExAllocatePool(NonPagedPool, Interface->Length);

        // C^[tF[XiWDMǗjRs[
        RtlCopyMemory(deviceExtension->Interface, Interface, 
							Interface->Length);

    }

USB_SelectInterfacesExit:

    // mۂs
    if (topOfInterfaceList)
        ExFreePool(topOfInterfaceList);
    if (urb)
        ExFreePool(urb);


    return ntStatus;
}
