VOID USB_GetBusInterface(IN PDEVICE_OBJECT DeviceObject)
{
    PIRP 		irp;
    KEVENT		event;
    NTSTATUS	ntStatus;
    PDEVICE_EXTENSION		deviceExtension;
    PIO_STACK_LOCATION		nextStack;

    deviceExtension = (PDEVICE_EXTENSION) DeviceObject->
							DeviceExtension;

    // OSWindows XPȍ~ׂ
    deviceExtension->isWindowsXPSupport =
        IoIsWdmVersionAvailable(
            WDM_MAJOR_VERSION,
            WINDOWS_XP_FUNCTION_SUPPORT_VALUE);
    if (!deviceExtension->isWindowsXPSupport) {
        return ;
    }

    // USBoXCtH[V擾pIRPmۂ
    irp = IoAllocateIrp(deviceExtension->StackDeviceObject->
							StackSize,FALSE);

    // IRPIʒm̃Cxg쐬
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // oXfoCXhCoIRPC
    // USB_IoCallDriverCompleteĂяo
    // Cxgݒ肵Ă炤
    IoSetCompletionRoutine(irp,
                           USB_IoCallDriverComplete,
                           &event,
                           TRUE,
                           TRUE,
                           TRUE
                           );

    // ʃhCoI/OX^bNP[Vmۂď
    nextStack = IoGetNextIrpStackLocation(irp);
    ASSERT(nextStack);
    nextStack->MajorFunction = IRP_MJ_PNP;
    nextStack->MinorFunction = IRP_MN_QUERY_INTERFACE;

    // oXC^[tF[X̃f[^DEVICE_EXTENSIONɊmۂ
    nextStack->Parameters.QueryInterface.Interface =
        (PINTERFACE) &deviceExtension->
							UsbBusInterfaceUSBDVersion;

    // C^[tF[Xdlf[^͂Ȃ
    nextStack->Parameters.QueryInterface.InterfaceSpecificData 
					= NULL;

    // USBDoXfoCXhCoGUIDݒ肷
    nextStack->Parameters.QueryInterface.InterfaceType =
                             &USB_BUS_INTERFACE_USBDI_GUID;

    // oXC^[tF[X̃TCYݒ肷
    nextStack->Parameters.QueryInterface.Size =
                         sizeof(USB_BUS_INTERFACE_USBDI_V1);

    // oXC^[tF[X̃o[W1iXg3-1jw肷
    nextStack->Parameters.QueryInterface.Version = 
					USB_BUSIF_USBDI_VERSION_1;

    // ʂ̃oXfoCXhCoɏ˗CI҂

    ntStatus = IoCallDriver(DeviceObject,irp);
    if(STATUS_PENDING == ntStatus) {
        KeWaitForSingleObject(&event,
                              Executive,
                              KernelMode,
                              FALSE,
                              NULL);
        ntStatus = irp->IoStatus.Status;
    }

    IoFreeIrp(irp);
}

NTSTATUS
USB_IoCallDriverComplete (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    )
{
    PKEVENT             event = (PKEVENT)Context;

    // ʃfoCXhCo珈I󂯂ăCxgݒ肷

    KeSetEvent (event, IO_NO_INCREMENT, FALSE);

    return STATUS_MORE_PROCESSING_REQUIRED;
}
