NTSTATUS
USB_DispatchPnp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    PIO_STACK_LOCATION  irpStack, nextStack;
    PDEVICE_EXTENSION   deviceExtension;
    NTSTATUS            ntStatus;
    BOOLEAN             DoPassToLowerDeviceDriver = TRUE;

    // ܂I/OX^bNP[Vl
    irpStack = IoGetCurrentIrpStackLocation (Irp);
    deviceExtension = DeviceObject->DeviceExtension;

    // ȏЉɃ}Ci[t@NVǉ
    USB_KdPrint (("Hello World I'm USB_DispatchPnp MinorFunc %02x\n",irpStack->MinorFunction));

    // }Ci[t@NVɏU蕪
    switch (irpStack->MinorFunction) {

    case IRP_MN_START_DEVICE:

        // ɉʃfoCXhCoɏ
        ntStatus = SendIrpSynchronously(deviceExtension->
							StackDeviceObject, Irp);
        if (ntStatus == STATUS_SUCCESS) {
            // ŃfoCXN̂
            // foCXȂǂ̏Lq
        }

        // ʃhCȍ͏IĂ̂
        // ʃfoCXhCȍ͍sȂ
        DoPassToLowerDeviceDriver = FALSE;

        break;

    case IRP_MN_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_REMOVE_DEVICE:

        ntStatus = SendIrpSynchronously(deviceExtension->
							StackDeviceObject, Irp);
        if (ntStatus == STATUS_SUCCESS) {
            // foCX폜ꂽꍇ
            // Kvȏ΂ɋLq
        }

        // foCX폜Ă̂ŁC
        // 쐬foCXIuWFNgȂǁCfoCX
        // ̃f[^鏈s

        // C^[tF[Xo^Ăꍇ́C폜
        IoSetDeviceInterfaceState(
            &deviceExtension->InterfaceSymbolicLinkName, 
							FALSE);
        RtlFreeUnicodeString(
            &deviceExtension->InterfaceSymbolicLinkName);

        // ʃfoCXhCofoCXIuWFNg
        // ؂藣āCKw\o^폜
        IoDetachDevice(deviceExtension->StackDeviceObject);

        // foCXIuWFNg폜
        IoDeleteDevice (DeviceObject);

        // ʃhCȍ͏IĂ̂
        // ʃfoCXhCȍ͍sȂ
        DoPassToLowerDeviceDriver = FALSE;

        break;

    case IRP_MN_QUERY_REMOVE_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_QUERY_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_CANCEL_REMOVE_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_CANCEL_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_SURPRISE_REMOVAL:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    default:
        // t@NVfoCXhCoȂ̂ŁC
        // ̂ق̃}Ci[R[h̓T|[gȂ 
        // ʂ̃foCXhCoɏC
        DoPassToLowerDeviceDriver = TRUE;
        break;

    } // switch MinorFunction

    if (DoPassToLowerDeviceDriver) {
        // ̊֐ŏȂꍇ́Cׂ
        // ʃfoCXhCoɂ̂܂ܗ
        // ŏĂ炤`ɂ
        IoSkipCurrentIrpStackLocation (Irp);
        ntStatus = IoCallDriver(
            deviceExtension->StackDeviceObject,Irp);
    }

    USB_KdPrint (("Exit USB_DispatchPnp ntStatus %x\n",ntStatus));


    return ntStatus;
}

NTSTATUS
SendIrpSynchronously (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    KEVENT   event;
    NTSTATUS status;

    USB_KdPrint (("I'm SendIrpSynchronously.\n"));

    // ʂ̃foCXhCoÎCxg
    // ҂̂ŁC̃Cxg
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // vOvCȂ̂ŁCI/OX^bN
    // P[VʃfoCXhCoI/OX^bN
    // P[VɃRs[
    IoCopyCurrentIrpStackLocationToNext(Irp);

    // ꍇɌĂяoė~֐o^
    // ̏ꍇ́CIrpCompleteEventSet֐ĂяoāC
    // ŃCxgݒ菈s
    IoSetCompletionRoutine(Irp,
                           IrpCompleteEventSet,
                           &event,
                           TRUE,
                           TRUE,
                           TRUE
                           );

    // ʂ̃foCXhCoĂяoāC
    // vOvC܂sĂ炤
    status = IoCallDriver(DeviceObject, Irp);

    // ʂ̃vOvCI܂ő҂
    // ̃CxǵCʃfoCXhCo
    // IƁCIrpCompleteEventSet֐
    // ɂĔƂ`ɂȂ
    if (status == STATUS_PENDING) {
        KeWaitForSingleObject(&event,
                             Executive,
                             KernelMode,
                             FALSE,
                             NULL
                             );
        status = Irp->IoStatus.Status;
    }

    return status;
}

NTSTATUS
IrpCompleteEventSet (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    )
{
    PKEVENT             event = (PKEVENT)Context;

    USB_KdPrint (("I'm IrpCompleteEventSet. \n"));

    // Cxgݒ肵āCCxg҂
    // KeWaitForSingleObject𔲂
    KeSetEvent (event, IO_NO_INCREMENT, FALSE);

    // IĂяȍꍇ͂̃Xe[^XŕԂ
    // ͂u܂ȂvƂoŎg
    return STATUS_MORE_PROCESSING_REQUIRED;
}