NTSTATUS USB_StartDevice(IN PDEVICE_OBJECT DeviceObject)
{
    NTSTATUS ntStatus;
    IN ULONG configurationDescriptorSize;
    PUSB_CONFIGURATION_DESCRIPTOR configurationDescriptor = 
					NULL;
    PDEVICE_EXTENSION deviceExtension;

    USB_KdPrint (("I'm USB_StartDevice.\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    // ----- RtBM[V̑Sf[^m邽߂-----
    // ----- ܂̓RtBM[VfBXNv^݂̂擾 -----

    configurationDescriptorSize = 
					sizeof(USB_CONFIGURATION_DESCRIPTOR);
    configurationDescriptor = ExAllocatePool(
                        NonPagedPool, 
                    configurationDescriptorSize+1);

    ntStatus = USB_GetConfigurationDescriptor(
                    DeviceObject,
                    configurationDescriptorSize,
                    configurationDescriptor
                );
    if ( !NT_SUCCESS(ntStatus) )
        goto USB_StartDeviceExit;

    // ----- ɑSRtBM[Vf[^擾-----

    // RtBM[VfBXNv^wTotalLengthݒ肷
    // ȂC擾RtBM[VfBXNv^
    // DEVICE_EXTENSION\̂ɂ̂ŁCłQƂł
    deviceExtension->TotalConfigDescriptorLength
        = (ULONG)configurationDescriptor->wTotalLength;
    ExFreePool(configurationDescriptor);
    deviceExtension->ConfigurationAllDescriptor
        = ExAllocatePool(
            NonPagedPool,
            deviceExtension->TotalConfigDescriptorLength+1);

    ntStatus = USB_GetConfigurationDescriptor(
                    DeviceObject,
                    deviceExtension->
							TotalConfigDescriptorLength,
                    deviceExtension->ConfigurationAllDescriptor
                );
    if ( !NT_SUCCESS(ntStatus) )
        goto USB_StartDeviceExit;

    USB_KdPrint (("USB_StartDevice Get ConfigAllDescriptor Length = %d\n",
        deviceExtension->TotalConfigDescriptorLength));

    // 擾RtBM[Vf[^Ƃ
    // RtBM[VsāCI
    ntStatus = USB_CreateConfiguration(DeviceObject,
               deviceExtension->ConfigurationAllDescriptor);

USB_StartDeviceExit:

    USB_KdPrint (("Exit USB_StartDevice ntStatus = %x\n",
        ntStatus));

    return ntStatus;
}

NTSTATUS USB_GetConfigurationDescriptor(
    IN PDEVICE_OBJECT DeviceObject,
    IN ULONG configurationDescriptorSize,
    IN PUSB_CONFIGURATION_DESCRIPTOR configurationDescriptor
)
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus;
    PURB urb = NULL;

    USB_KdPrint (("I'm USB_GetConfigurationDescriptor.\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    // GET_CONFIGURATION_DESCRIPTOR𔭍s邽߂URBmۂ
    urb = ExAllocatePool(NonPagedPool,
        sizeof(struct _URB_CONTROL_DESCRIPTOR_REQUEST));

    // GET_CONFIGURATION_DESCRIPTOR𔭍s邽߂URB쐬
    UsbBuildGetDescriptorRequest(urb,
        (USHORT) sizeof (struct 
							_URB_CONTROL_DESCRIPTOR_REQUEST),
        USB_CONFIGURATION_DESCRIPTOR_TYPE,
        0,
        0,
        configurationDescriptor,
        NULL,
        configurationDescriptorSize,
        NULL);

    // GET_CONFIGURATION_DESCRIPTOR𔭍s
    ntStatus = USB_CallUSBD(DeviceObject, urb);

    if (urb)
        ExFreePool(urb);

    return ntStatus;
}

NTSTATUS USB_CreateConfiguration(
    IN PDEVICE_OBJECT                DeviceObject,
    IN PUSB_CONFIGURATION_DESCRIPTOR ConfigurationDescriptor
    )
{
#define USB_STORAGE_CLASS_CODE 8
    PDEVICE_EXTENSION           deviceExtension;
    NTSTATUS                    ntStatus;
    PURB                        urb = NULL;
    ULONG                       i, dir;
    PUSB_INTERFACE_DESCRIPTOR   interfaceDescriptor;
    PUSBD_INTERFACE_INFORMATION Interface;
    PUSBD_INTERFACE_LIST_ENTRY 
							interfaceList,topOfInterfaceList;

    USB_KdPrint (("I'm USB_SelectConfiguration.\n"));

    // SELECT_CONFIGURATION
    // ̃foCXhCo̓C^[tF[X
    // 1̃foCXT|[gĂ

    deviceExtension = DeviceObject->DeviceExtension;

    // C^[tF[XiWDMŊǗjXg擾
    // 2mۂĂ̂́C2ڂĨ}[LOƂĎg߂ł

    topOfInterfaceList =interfaceList
        = ExAllocatePool(NonPagedPool,sizeof
							(USBD_INTERFACE_LIST_ENTRY) * 2);
    if(!interfaceList) {
        ntStatus = STATUS_NO_MEMORY;
        goto USB_CreateConfigurationExit;
    }

    // C^[tF[XfBXNv^擾
    interfaceDescriptor =
        USBD_ParseConfigurationDescriptorEx(
            ConfigurationDescriptor,
            ConfigurationDescriptor,
            //T[`ŏ̃RtBM[VfBXNv^
            -1,                        // interface number
            -1,                        // alternate setting
            USB_STORAGE_CLASS_CODE,    // interface class
            -1,                        // interface subclass
            -1 );                      // interface protocol

    // C^[tF[XXgXV
    interfaceList->InterfaceDescriptor = interfaceDescriptor;
    interfaceList->Interface = NULL;

    // C^[tF[X1ŏI
    interfaceList++;
    interfaceList->InterfaceDescriptor = NULL;
    interfaceList->Interface = NULL;

    // SelectConfiguration̂߂URBmۂ
    // Kvȃf[^tH[}bg
    urb = USBD_CreateConfigurationRequestEx(
            ConfigurationDescriptor, topOfInterfaceList);

    // USBD_ParseConfigurationDescriptorExŐݒ肳ꂽ
    // C^[tF[XiWDMǗj擾
    Interface = &urb->UrbSelectConfiguration.Interface;

    // pCv̍ő]TCYCʂɑOɂ炩ߐݒ肵Ă
    // {foCXhCoł́C64KB܂ňCɓ]ł悤ɂ
    for (i = 0; i < Interface->NumberOfPipes; i++) {
        Interface->Pipes[i].MaximumTransferSize = 65536;
    }

    // ZNgRtBM[Vs
    ntStatus = USB_CallUSBD(DeviceObject, urb);

    // ZNgRtBM[V͐H
    if (NT_SUCCESS(ntStatus)) {

        // ̂ŁCUSBf[^\
        USB_KdPrint (("USB_CreateConfiguration Success! ---------- \n"));
        USB_KdPrint (("Class, subclass, protocol 0x%x 0x%x 0x%x\n",
            Interface->Class,
            Interface->SubClass,
            Interface->Protocol));
        for (i = 0; i < Interface->NumberOfPipes; i++) {
            int dir;

            USB_KdPrint (("Endpoint[Addr:%02x] Type %x MaxPacketSize %d \n",
                Interface->Pipes[i].EndpointAddress,
                Interface->Pipes[i].PipeType,
                Interface->Pipes[i].MaximumPacketSize));

            // oNIN/OUT̃pCvCtH[V
            // DEVICE_EXTENSIONɃāCg悤ɂ
            if (Interface->Pipes[i].PipeType == UsbdPipeTypeBulk) {               
					dir = (USBD_PIPE_DIRECTION_IN(&Interface->Pipes[i])) ?
								USBD_TRANSFER_DIRECTION_IN :
									 USBD_TRANSFER_DIRECTION_OUT;
                deviceExtension->BulkPipeInformation[dir] = 
										Interface->Pipes[i];
            }
        }
        USB_KdPrint (("-----------------------------\n"));
    }

    DbgBreakPoint(); 	// ō폜DŃ^[QbgPC~߂ċĂ݂

USB_CreateConfigurationExit:

    // mۂ̉
    if (topOfInterfaceList)
        ExFreePool(topOfInterfaceList);

    if (urb)
        ExFreePool(urb);

    return ntStatus;
}

NTSTATUS USB_CallUSBD(
    IN PDEVICE_OBJECT DeviceObject,
    IN PURB Urb
    )
{
    NTSTATUS ntStatus, status = STATUS_SUCCESS;
    PDEVICE_EXTENSION deviceExtension;
    PIRP irp;
    KEVENT event;
    IO_STATUS_BLOCK ioStatus;
    PIO_STACK_LOCATION nextStack;

    // URBʂ̃foCXhCoɑď˗
    // ICxgő҂
    // deviceExtensionɂUSBoXfoCXhCõIuWFNg
    // ̂ƂiAddDeviceɐݒ肳ĂƉ肷j
    deviceExtension = DeviceObject->DeviceExtension;

    // ʃfoCXhCȍ҂Cxg̏
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // IOCTL_INTERNAL_USB_SUBMIT_URBvsIRP쐬
    irp = IoBuildDeviceIoControlRequest(
                IOCTL_INTERNAL_USB_SUBMIT_URB,
                deviceExtension->StackDeviceObject,
                NULL,
                0,
                NULL,
                0,
                TRUE, // IRP_MJ_INTERNAL_DEVICE_CONTROLw
                &event,
                &ioStatus);

    // ʃhCoI/OX^bNP[V擾
    nextStack = IoGetNextIrpStackLocation(irp);

    // p[^URBw肷
    nextStack->Parameters.Others.Argument1 = Urb;

    // ʃfoCXhCoioXfoCXhCojɏ˗
    ntStatus = IoCallDriver(deviceExtension->StackDeviceObject,
                            irp);

    // ICxgő҂
    if (ntStatus == STATUS_PENDING)
    {
        ntStatus = KeWaitForSingleObject(
                        &event,
                        Executive,
                        KernelMode,
                        FALSE,
                        NULL);
    }
    else {
        ioStatus.Status = ntStatus;
    }
    ntStatus = ioStatus.Status;

    return ntStatus;
}