// ---------- IRP_MJ_DEVICE_CONTROL ---------

NTSTATUS USB_ProcessIOCTL(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp
    )
{
    NTSTATUS            ntStatus;
    PIO_STACK_LOCATION  irpStack;
    PDEVICE_EXTENSION   deviceExtension;
    PVOID               ioBuffer;
    ULONG               inputBufferLength, outputBufferLength;

    USB_KdPrint (("Hello World I'm USB_ProcessIOCTL \n"));

    deviceExtension     = DeviceObject->DeviceExtension;
    irpStack            = IoGetCurrentIrpStackLocation (Irp);

    // obt@[hI/Õobt@擾
    ioBuffer		= Irp->AssociatedIrp.SystemBuffer;
    inputBufferLength	= irpStack->
					Parameters.DeviceIoControl.InputBufferLength;
    outputBufferLength	= irpStack->
					Parameters.DeviceIoControl.OutputBufferLength;

    // R[hɉďU蕪
    switch (irpStack->Parameters.DeviceIoControl.
					IoControlCode) {

    case IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR:

        // foCXɎ擾RtBM[VfBXNv^
        // VXeobt@ɃRs[
        RtlCopyMemory(
            ioBuffer,
            deviceExtension->ConfigurationAllDescriptor,
            deviceExtension->TotalConfigDescriptorLength);

        // obt@ɃRs[ݒ肵Ă
        Irp->IoStatus.Information =
            deviceExtension->TotalConfigDescriptorLength;
        ntStatus = STATUS_SUCCESS;

        USB_KdPrint (("IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR size=%d\n",deviceExtension->TotalConfigDescriptorLength));

        break;

    default:
        ntStatus = STATUS_INVALID_PARAMETER;
    }

    // IRP̊
    Irp->IoStatus.Status = ntStatus;
    IoCompleteRequest (Irp, IO_NO_INCREMENT);
    USB_KdPrint (("Exit USB_ProcessIOCTL status %x\n", 
					ntStatus));

    return ntStatus;
}
