VOID USB_GetBusInterface(IN PDEVICE_OBJECT DeviceObject)
{
    PIRP			irp;
    KEVENT		event;
    NTSTATUS	ntStatus;
    PDEVICE_EXTENSION		deviceExtension;
    PIO_STACK_LOCATION		nextStack;

    deviceExtension = (PDEVICE_EXTENSION) DeviceObject->
					DeviceExtension;

    USB_KdPrint (("Enter USB_GetBusInterface \n"));

    // OSWindows XPȍ~ǂׂ
    deviceExtension->isWindowsXPSupport =
        IoIsWdmVersionAvailable(
            WDM_MAJOR_VERSION,
            WINDOWS_XP_FUNCTION_SUPPORT_VALUE);

    if (!deviceExtension->isWindowsXPSupport) {
        USB_KdPrint (("This OS is older than Windows XP.\n"));
        return ;
    }
#if DBG 	// \Ȃ̂ŁCReleaseɂ͕sv
    else {
        USB_KdPrint (("This OS is Windows XP or later \n"));
    }
#endif

    // USBoXCtH[VmۗpIRPmۂ
    irp = IoAllocateIrp(deviceExtension->StackDeviceObject->
					StackSize,FALSE);

    // IRPIʒm̃Cxg쐬
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // IRPoXfoCXhCo
    // IrpCompleteEventSetĂŃCxg
    // ݒ肵Ă炤
    IoSetCompletionRoutine(irp,
                           IrpCompleteEventSet,
                           &event,
                           TRUE,
                           TRUE,
                           TRUE
                           );

    // ʃhCoI/OX^bNP[Vmۂď
    nextStack = IoGetNextIrpStackLocation(irp);
    ASSERT(nextStack);
    nextStack->MajorFunction = IRP_MJ_PNP;
    nextStack->MinorFunction = IRP_MN_QUERY_INTERFACE;

    // oXC^[tF[X̃f[^DEVICE_EXTENSIONɊmۂ
    nextStack->Parameters.QueryInterface.Interface =
        (PINTERFACE) &deviceExtension->UsbBusInterfaceUSBD;

    // C^[tF[Xdlf[^͕sv
    nextStack->Parameters.QueryInterface.
							InterfaceSpecificData = NULL;

    // USBDoXfoCXhCoGUIDݒ肷
    nextStack->Parameters.QueryInterface.InterfaceType =
                            &USB_BUS_INTERFACE_USBDI_GUID;

    // oXC^[tF[X̃TCYݒ肷
    nextStack->Parameters.QueryInterface.Size =
                         sizeof(USB_BUS_INTERFACE_USBDI_V1);

    // oXC^[tF[X̃o[W1(Xg3-19)w肷
    nextStack->Parameters.QueryInterface.Version = 
					USB_BUSIF_USBDI_VERSION_1;

    // ʂ̃oXfoCXhCoɏ˗CI҂
    ntStatus = IoCallDriver(DeviceObject,irp);
    if(STATUS_PENDING == ntStatus) {
        KeWaitForSingleObject(&event,
                              Executive,
                              KernelMode,
                              FALSE,
                              NULL);
        ntStatus = irp->IoStatus.Status;
    }

    DbgBreakPoint();

    IoFreeIrp(irp);
}
