NTSTATUS
USB_DispatchPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus;
    PIO_STACK_LOCATION  irpStack;

    deviceExtension = DeviceObject->DeviceExtension;
    irpStack = IoGetCurrentIrpStackLocation (Irp);

    USB_KdPrint (("Hello World I'm USB_DispatchPower func %x\n",
        irpStack->MinorFunction));

    // d͊Ǘ̊e͂̂悤ɗv
    switch (irpStack->MinorFunction) {

    case IRP_MN_SET_POWER:

        // ----------- p[ɂ ----------
        // ́Ct@NVfoCXhCo̗ł
        // foCXp[ɂẮCoXfoCXhCo
        // CāCVXep[ɑΉR[hɂȂĂ
        switch (irpStack->Parameters.Power.Type) {

        case SystemPowerState:
        // VXep[USBt@NVfoCXhCoŖʓ|
        return SystemSetPower(DeviceObject,Irp);

        case DevicePowerState:
            //\ďI
            USB_KdPrint (("DevicePowerState PowerState=%x \n",irpStack->Parameters.Power.State ));
            break;
        }

        break;

    case IRP_MN_QUERY_POWER:

        switch (irpStack->Parameters.Power.Type) {

        case SystemPowerState:
        // VXep[ύXĂ悢₢킹Ă
        // KvȂ΂ɏ
        break;

        case DevicePowerState:
        // foCXp[ύXĂ悢₢킹Ă
        // KvȂ΂ɏ

        break;

        }
        break;

    default:
        break;

    }

    // ʃfoCXhCoɏۓĂ
    // d͊Ǘsꍇ́CȉR[ĥ悤
    // PoStartNextPowerIrpCPoCallDriverƂ
    // Po?????Ƃ`APIg
    PoStartNextPowerIrp( Irp);
    IoSkipCurrentIrpStackLocation(Irp);

    ntStatus = PoCallDriver (deviceExtension->StackDeviceObject, Irp);

    return ntStatus;
}

NTSTATUS SystemSetPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    NTSTATUS								ntStatus;
    POWER_STATE							powerState;
    PDEVICE_EXTENSION					deviceExtension;
    PIO_STACK_LOCATION				irpStack;
    SYSTEM_POWER_STATE				systemState;
    DEVICE_POWER_STATE				deviceState;
    PPOWER_COMPLETION_CONTEXT	powerContext;

    deviceExtension = (PDEVICE_EXTENSION)DeviceObject->
							DeviceExtension;
    irpStack = IoGetCurrentIrpStackLocation(Irp);

    // VXeXe[^X擾
    systemState = irpStack->Parameters.Power.State.
							SystemState;

    // J[lݒ肵VXep[Xe[gɑΉ
    // foCXXe[gݒ肷ɂ́CɓK؂Ȓl
    deviceState = deviceExtension->
						DeviceCapabilities.DeviceState[systemState];
    powerState.DeviceState = deviceState;

    USB_KdPrint (("SystemSetPower set DeviceState %x\n",deviceState));

    // p[䊮֐̃p[^mۂāCꂼݒ肷
    powerContext = (PPOWER_COMPLETION_CONTEXT)
                   ExAllocatePool(NonPagedPool,
                         sizeof(POWER_COMPLETION_CONTEXT));
    powerContext->DeviceObject = DeviceObject;
    powerContext->Irp = Irp;

    // foCX̃p[Zbg𔭍s
    // ICDevicePowerSetComplete֐Ă΂
    ntStatus = PoRequestPowerIrp(
        deviceExtension->PhysicalDeviceObject,
        irpStack->MinorFunction,
        powerState, 	// foCXp[Xe[gXVĂ
        (PREQUEST_POWER_COMPLETE)DevicePowerSetComplete,
        powerContext,
        NULL);

    if(NT_SUCCESS(ntStatus))
        return ntStatus; 	// ȂΏI

    // sꍇ́C̃p[}l[WgIRP

    PoStartNextPowerIrp(Irp);
    Irp->IoStatus.Status = ntStatus;
    Irp->IoStatus.Information = 0;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    if(powerContext) {
        ExFreePool(powerContext);
    }

    return ntStatus;
}


VOID DevicePowerSetComplete(
    IN PDEVICE_OBJECT DeviceObject,
    IN UCHAR MinorFunction,
    IN POWER_STATE PowerState,
    IN PVOID Context,
    IN PIO_STATUS_BLOCK IoStatus
    )
{
    PIRP                      Irp;
    PDEVICE_EXTENSION         deviceExtension;
    PPOWER_COMPLETION_CONTEXT powerContext;

    powerContext = (PPOWER_COMPLETION_CONTEXT) Context;
    Irp = powerContext->Irp;
    deviceExtension = powerContext->DeviceObject->
							DeviceExtension;

    ExFreePool(powerContext);

    // ̃p[}l[WgIRP悤ɂ
    PoStartNextPowerIrp(Irp);
	IoSkipCurrentIrpStackLocation(Irp);

    // ʃfoCXhCoIRP𓊂邱ƂŁC
    // VXep[Xe[gI
    PoCallDriver (deviceExtension->StackDeviceObject, Irp);

    USB_KdPrint (("enter DevicePowerSetComplete st %x \n",
        Irp->IoStatus.Status));
}
