#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "UsbStorageDevice.h"

#include <PSHPACK1.H>       //PACK_START

#define CBW_COMMAND_BUFFER_LENGTH 16

typedef struct _BULKONLY_CMD_BUF
{
    UCHAR     CBWSig[4];
    ULONG     CBWTag;
    ULONG     CBWDataLength;
    UCHAR     CBWFlags;
    UCHAR     CBWLun;
    UCHAR     CBWCBLength;
    UCHAR     CBBuffer[CBW_COMMAND_BUFFER_LENGTH]; 
						// 789012345678901
} BULKONLY_CMD_BUF, *PBULKONLY_CMD_BUF;

typedef struct _BULKONLY_STATUS_BUF
{
    UCHAR     CSWS[4];
    ULONG     CSWTag;
    ULONG     CSWDataResidue;
    UCHAR     CSWStatus;

} BULKONLY_STATUS_BUF, *PBULKONLY_STATUS_BUF;

#include <POPPACK.H>		//PACK_END

// VOl`̏ݒ
#define CBWSigInitialize() *((ULONG *)&(BulkCommandBuffer.CBWSig[0])) = 0x43425355;

// ^Oԍ̏ݒ
#define CBWTagInitialize()  CBWTag = 0x80000000

class CBulkOnlyStorageDevice : public CUsbStorageDevice
{
public:
    CBulkOnlyStorageDevice();
    virtual ~CBulkOnlyStorageDevice();

    // Xg[WfoCX̏
    BOOL DeviceInitialize(CUsbDevice* InitializeUsbDevice);

    //ATAPIR}hpPbgfoCXɑM
    BOOL SendAtapiRequestPacket(PVOID atapi,ULONG 
					TransferDataLength,BOOL isRead);

    //Xe[^X̎擾
    BOOL GetStorageDeviceStatus(VOID);

private:

    // R}hݒ肷CBW
    BULKONLY_CMD_BUF BulkCommandBuffer;

    // Xe[^X擾CSW
    BULKONLY_STATUS_BUF BulkStatusBufffer;

    // CBvŐݒ肷^Oԍ
    ULONG CBWTag;
};
