// usbtest.h
// USBXg[WfoCXeXgpfoCXhCo
// (C) 2003 Kenichiro Hamada

#ifndef _USBTEST_H
#define _USBTEST_H

#ifdef DRIVER

#include <wdm.h>
#include <usbdi.h>
#include <usbdlib.h>
#include <stdio.h>
#include <initguid.h> 		//AddDeviceLqɒǉ
#include <usbbusif.h> 		//foCXxLqɒǉ

#define WDM_MAJOR_VERSION 1
#define WINDOWS_XP_FUNCTION_SUPPORT_VALUE 0x20

#if DBG
#define USB_KdPrint(_x_) DbgPrint _x_;
#else
#define USB_KdPrint(_x_)
#endif

//////////////////////////////////////////////////
//              \̒`                      //
//////////////////////////////////////////////////

// foCXhCo̊g\

// foCXhCo̊g\
typedef struct _DEVICE_EXTENSION {

    // oXfoCXhCoIuWFNg
    PDEVICE_OBJECT PhysicalDeviceObject;

    // ʂ̃foCXhCoIuWFNg
    PDEVICE_OBJECT StackDeviceObject;

    // AvP[VƂ̃C^[tF[X
    // V{N̖OipXɑj
    UNICODE_STRING InterfaceSymbolicLinkName;

    // 擾RtBM[VfBXNv^
    PUSB_CONFIGURATION_DESCRIPTOR ConfigurationAllDescriptor;

    // RtBM[VfBXNv^̒
    ULONG TotalConfigDescriptorLength;

    // oNIN/OUT̃pCvCtH[[V
    USBD_PIPE_INFORMATION BulkPipeInformation[2];

    // ZbgKvȃGh|CgpCv
    PUSBD_PIPE_INFORMATION NeedResetPipe;

    // Windows̃o[WXPȍ~ǂtO
    BOOLEAN isWindowsXPSupport;

    // oX̃CtH[V(XPΉ)
    USB_BUS_INTERFACE_USBDI_V1 UsbBusInterfaceUSBD;

} DEVICE_EXTENSION, *PDEVICE_EXTENSION;

// oN][`󂯎p[^ 
typedef struct _BULK_RW_CONTEXT {

    // URB
    PURB              Urb;		
    
    // DEVICE_EXTENSION\
    PDEVICE_EXTENSION deviceExtension;

    //]pCṽCtH[V
    PUSBD_PIPE_INFORMATION pipeInformation;

} BULK_RW_CONTEXT, *PBULK_RW_CONTEXT;




//////////////////////////////////////////////////
//             ֐`                         //
//////////////////////////////////////////////////

// ---------- AddDevice ----------

NTSTATUS USB_PnPAddDevice(
    IN PDRIVER_OBJECT DriverObject,
    IN PDEVICE_OBJECT PhysicalDeviceObject
    );

// ---------- UnLoad ----------

VOID USB_Unload(IN PDRIVER_OBJECT DriverObject);

// ---------- IRP_MJ_PNP ----------

NTSTATUS USB_DispatchPnp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    );

NTSTATUS
SendIrpSynchronously (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

NTSTATUS
IrpCompleteEventSet (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    );

NTSTATUS USB_StartDevice(IN  PDEVICE_OBJECT DeviceObject);

NTSTATUS USB_GetConfigurationDescriptor(
    IN PDEVICE_OBJECT DeviceObject,
    IN ULONG configurationDescriptorSize,
    IN PUSB_CONFIGURATION_DESCRIPTOR configurationDescriptor
);

NTSTATUS USB_CreateConfiguration(
    IN PDEVICE_OBJECT                DeviceObject,
    IN PUSB_CONFIGURATION_DESCRIPTOR ConfigurationDescriptor
    );

VOID USB_GetBusInterface(IN PDEVICE_OBJECT DeviceObject);

NTSTATUS USB_CallUSBD(
    IN PDEVICE_OBJECT DeviceObject,
    IN PURB Urb
    );

// ---------- IRP_MJ_POWER ----------

NTSTATUS USB_DispatchPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    );

// ---------- IRP_MJ_CREATE ----------

NTSTATUS USB_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

// ---------- IRP_MJ_CLOSE -----------

NTSTATUS USB_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

// ---------- IRP_MJ_DEVICE_CONTROL ----------

NTSTATUS USB_ProcessIOCTL(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

NTSTATUS USB_ClassRequest(
    PDEVICE_OBJECT DeviceObject,
    PCHAR   pBuffer,
    PULONG length
    );

NTSTATUS
USB_ResetPipe(
    PDEVICE_OBJECT DeviceObject
);

// ---------- IRP_MJ_READ ----------
// ---------- IRP_MJ_WRITE ----------

NTSTATUS USB_BulkReadWrite(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    );

NTSTATUS
USB_BulkCompletion(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp,
    IN PVOID          Context
    );

PURB USB_GetBulkTransferUrb (
    IN PDEVICE_EXTENSION deviceExtension,
    IN PIRP  Irp,
    IN ULONG transferLength,
    IN PMDL  mdl,
    OUT PUSBD_PIPE_INFORMATION *pipeInformation
    );

NTSTATUS USB_IoCallDriverToTransferBulkData(
    IN PIRP Irp,
    IN PBULK_RW_CONTEXT rwContext
    );

#endif      //#ifdef DRIVER

// {D7FCF225-ACD8-44a5-A0E8-959EE5DE56ED}
DEFINE_GUID(USBTEST_GUID,
	0xd7fcf225, 0xacd8, 0x44a5, 0xa0, 0xe8, 0x95, 0x9e, 0xe5, 0xde, 0x56, 0xed);

///////////////////////////////////////////////////
//         I/O Control ̃R[h`              //
///////////////////////////////////////////////////

#define USBDRIVE_IOCTL_INDEX  0x0800

#define IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR  \
            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                USBDRIVE_IOCTL_INDEX+0,\
                METHOD_BUFFERED,  \
                FILE_ANY_ACCESS)

#define IOCTL_USB_CLASS_REQUEST \
            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                USBDRIVE_IOCTL_INDEX+1,\
                METHOD_BUFFERED,  \
                FILE_ANY_ACCESS)

#define IOCTL_USB_RESET_PIPE \
            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                USBDRIVE_IOCTL_INDEX+2,\
                METHOD_BUFFERED,  \
                FILE_ANY_ACCESS)

#define IOCTL_USB_CHECK_SPEED \
            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                USBDRIVE_IOCTL_INDEX+3,\
                METHOD_BUFFERED,  \
                FILE_ANY_ACCESS)

#endif      //#ifndef _USB2TEST_H
