// usbtest.c
// USBXg[WfoCXeXgpfoCXhCo
// (C) 2003 Kenichiro Hamada

#define DRIVER

#include "usbtest.h"

// ---------- DriverEntry ----------

NTSTATUS
DriverEntry(
    IN PDRIVER_OBJECT DriverObject,
    IN PUNICODE_STRING RegistryPath
    )
{

    USB_KdPrint (("Hello World I'm DriverEntry \n"));

    // e̊֐o^
    DriverObject->DriverExtension->AddDevice			= USB_PnPAddDevice;
    DriverObject->DriverUnload								= USB_Unload;
    DriverObject->MajorFunction[IRP_MJ_PNP]				= USB_DispatchPnp;
    DriverObject->MajorFunction[IRP_MJ_POWER]			= USB_DispatchPower;
    DriverObject->MajorFunction[IRP_MJ_CREATE]			= USB_Create;
    DriverObject->MajorFunction[IRP_MJ_CLOSE]			= USB_Close;
    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL]	= USB_ProcessIOCTL;
    DriverObject->MajorFunction[IRP_MJ_READ]			= USB_BulkReadWrite;	
    DriverObject->MajorFunction[IRP_MJ_WRITE]			= USB_BulkReadWrite;

    return STATUS_SUCCESS;
}

// ---------- AddDevice ----------

NTSTATUS
USB_PnPAddDevice(
    IN PDRIVER_OBJECT DriverObject,
    IN PDEVICE_OBJECT PhysicalDeviceObject
    )
{
    NTSTATUS                ntStatus = STATUS_SUCCESS;
    PDEVICE_OBJECT          deviceObject = NULL;
    PDEVICE_EXTENSION       deviceExtension;

    USB_KdPrint (("Hello World I'm USB_PnPAddDevice \n"));


    // ̃foCX̃foCXIuWFNg쐬
    ntStatus = IoCreateDevice (DriverObject,
        sizeof (DEVICE_EXTENSION),
        NULL,
        FILE_DEVICE_UNKNOWN,
        0,
        FALSE,
        &deviceObject);

    if (ntStatus == STATUS_SUCCESS) {

        // foCXIuWFNg̍쐬ɐ

        // deviceExtension̓x_g|C^ł
        // ʏ́CDeviceɕKvɂȂǗC
        // DEVICE_EXTENSION\̂ɂĊǗ
        deviceExtension = deviceObject->DeviceExtension;

        // VC^[tF[Xo^
        // āC̃V{bNNij󂯎
        // ̃R[h́C炩DEVICE_EXTENSION\̂
        // SymbolicLinkName`Ă̂ƂĂ
        ntStatus = 
			IoRegisterDeviceInterface(PhysicalDeviceObject,
	            &USBTEST_GUID, NULL,
		        &deviceExtension->InterfaceSymbolicLinkName);
        if( ntStatus != STATUS_SUCCESS)
        {
            // GUIDo^ɎsȂ΁C쐬foCXIuWFNg
            // jāCI
            IoDeleteDevice(deviceObject);
            return ntStatus;
        }

        // o^C^[tF[XLɂāCAvP[V
        // foCXhCoɃANZXł悤ɂ
        IoSetDeviceInterfaceState(
            &deviceExtension->InterfaceSymbolicLinkName, TRUE);

        // {hCoł̓f[^ʐMɃ_CNgI/OĝŁC錾Ă
        deviceObject->Flags |= DO_DIRECT_IO;

        // dǗPASSIVE_LEVELōs킹
        deviceObject->Flags |= DO_POWER_PAGABLE;

        // CjVCYÎŁCtÕCjVCY
        // قɃtOݒ肷ꍇ́CŋLqĂ
        deviceObject->Flags &= ~DO_DEVICE_INITIALIZING;

        // oXfoCXhCõfoCXIuWFNgǗ邽߂
        // DeviceExtensionɂ炩߂̃o[ݒ肵ĂāC
        // oXfoCXhCõfoCXIuWFNgRs[Ă
        deviceExtension->PhysicalDeviceObject=PhysicalDeviceObject;

        // IoAttachDeviceToDeviceStack֐ĂяoāCʂ̃foCX
        // hCõfoCXIuWFNgo
        // ɁCʂ̃foCXhCõfoCXIuWFNgǗ邽߂ɁC
        // DeviceExtensionɂ炩߂̃o[ݒ肵ĂāC
        // ʂ̃foCXhCõfoCXIuWFNgRs[Ă
        deviceExtension->StackDeviceObject =
            IoAttachDeviceToDeviceStack(deviceObject, 
							PhysicalDeviceObject);

        // DEVICE_EXTENSION\̂̃ȍ
        deviceExtension->NeedResetPipe=NULL;
   }

   return ntStatus;
}

// ---------- UnLoad ----------

VOID USB_Unload(IN PDRIVER_OBJECT DriverObject)
{
    USB_KdPrint (("Hello World I'm USB_Unload \n"));
}

// ---------- IRP_MJ_PNP ----------

NTSTATUS
USB_DispatchPnp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    PIO_STACK_LOCATION  irpStack, nextStack;
    PDEVICE_EXTENSION   deviceExtension;
    NTSTATUS            ntStatus;
    BOOLEAN             DoPassToLowerDeviceDriver = TRUE;

    // ܂I/OX^bNP[Vl
    irpStack = IoGetCurrentIrpStackLocation (Irp);
    deviceExtension = DeviceObject->DeviceExtension;

    // ȏЉɃ}Ci[t@NVǉ
    USB_KdPrint (("Hello World I'm USB_DispatchPnp MinorFunc %02x\n",irpStack->MinorFunction));

    // }Ci[t@NVɏU蕪
    switch (irpStack->MinorFunction) {

    case IRP_MN_START_DEVICE:

        // ɉʃfoCXhCoɏ 
        ntStatus = SendIrpSynchronously(deviceExtension->StackDeviceObject, Irp);
        if (ntStatus == STATUS_SUCCESS) {
            // foCXIuWFNg
            ntStatus = USB_StartDevice(DeviceObject);
        }

        // ʃhCȍ͏IĂ̂
        // ʃfoCXhCȍ͍sȂ
        DoPassToLowerDeviceDriver = FALSE;

        // IRP
        IoCompleteRequest (Irp, IO_NO_INCREMENT);

        break;

    case IRP_MN_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_REMOVE_DEVICE:

        ntStatus = SendIrpSynchronously(deviceExtension->
							StackDeviceObject, Irp);
        if (ntStatus == STATUS_SUCCESS) {
            // foCX폜ꂽꍇ
            // Kvȏ΂ɋLq
        }

        // foCX폜Ă̂ŁC
        // 쐬foCXIuWFNgȂǁCfoCX
        // ̃f[^鏈s

        // C^[tF[Xo^Ăꍇ́C폜
        IoSetDeviceInterfaceState(
            &deviceExtension->InterfaceSymbolicLinkName, 
							FALSE);
        RtlFreeUnicodeString(
            &deviceExtension->InterfaceSymbolicLinkName);

        // ʃfoCXhCofoCXIuWFNg
        // ؂藣āCKw\o^폜
        IoDetachDevice(deviceExtension->StackDeviceObject);

		// RtBM[VfBXNv^̂߂
		// mۂ
		if (deviceExtension->ConfigurationAllDescriptor) 
			ExFreePool(deviceExtension->ConfigurationAllDescriptor);

        // foCXIuWFNg폜
        IoDeleteDevice (DeviceObject);

        // ʃhCȍ͏IĂ̂
        // ʃfoCXhCȍ͍sȂ
        DoPassToLowerDeviceDriver = FALSE;

        break;

   case IRP_MN_QUERY_REMOVE_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_QUERY_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_CANCEL_REMOVE_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_CANCEL_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_SURPRISE_REMOVAL:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_QUERY_CAPABILITIES:

         // ɉʃfoCXhCoɏ
        ntStatus = SendIrpSynchronously(deviceExtension->StackDeviceObject, Irp);
        if (NT_SUCCESS (ntStatus)) {
            PDEVICE_CAPABILITIES pDeviceCapabilities;

            // foCXPCpreBf[^擾
            pDeviceCapabilities =
                irpStack->Parameters.DeviceCapabilities.Capabilities;
            deviceExtension->DeviceCapabilities = *pDeviceCapabilities;
            USB_KdPrint (("Get DEVICE_CAPABILITIES %p version %d \n",
                pDeviceCapabilities,
                deviceExtension->DeviceCapabilities.Version));
        }

        Irp->IoStatus.Status = ntStatus;
        DoPassToLowerDeviceDriver = FALSE;

        break;

    default:
        // t@NVfoCXhCoȂ̂ŁC
        // ̂ق̃}Ci[R[h̓T|[gȂ 
        // ʂ̃foCXhCoɏC
        DoPassToLowerDeviceDriver = TRUE;
        break;

    } // switch MinorFunction

    if (DoPassToLowerDeviceDriver) {
        // ̊֐ŏȂꍇ́Cׂ
        // ʃfoCXhCoɂ̂܂ܗ
        // ŏĂ炤`ɂ
        IoSkipCurrentIrpStackLocation (Irp);
        ntStatus = IoCallDriver(
            deviceExtension->StackDeviceObject,Irp);
    }

    USB_KdPrint (("Exit USB_DispatchPnp ntStatus %x\n",ntStatus));


    return ntStatus;
}

NTSTATUS
SendIrpSynchronously (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    KEVENT   event;
    NTSTATUS status;

    USB_KdPrint (("I'm SendIrpSynchronously.\n"));

    // ʂ̃foCXhCoÎCxg
    // ҂̂ŁC̃Cxg
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // vOvCȂ̂ŁCI/OX^bN
    // P[VʃfoCXhCoI/OX^bN
    // P[VɃRs[
    IoCopyCurrentIrpStackLocationToNext(Irp);

    // ꍇɌĂяoė~֐o^
    // ̏ꍇ́CIrpCompleteEventSet֐ĂяoāC
    // ŃCxgݒ菈s
    IoSetCompletionRoutine(Irp,
                           IrpCompleteEventSet,
                           &event,
                           TRUE,
                           TRUE,
                           TRUE
                           );

    // ʂ̃foCXhCoĂяoāC
    // vOvC܂sĂ炤
    status = IoCallDriver(DeviceObject, Irp);

    // ʂ̃vOvCI܂ő҂
    // ̃CxǵCʃfoCXhCo
    // IƁCIrpCompleteEventSet֐
    // ɂĔƂ`ɂȂ
    if (status == STATUS_PENDING) {
        KeWaitForSingleObject(&event,
                             Executive,
                             KernelMode,
                             FALSE,
                             NULL
                             );
        status = Irp->IoStatus.Status;
    }

    return status;
}

NTSTATUS
IrpCompleteEventSet (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    )
{
    PKEVENT             event = (PKEVENT)Context;

    USB_KdPrint (("I'm IrpCompleteEventSet. \n"));

    // Cxgݒ肵āCCxg҂
    // KeWaitForSingleObject𔲂
    KeSetEvent (event, IO_NO_INCREMENT, FALSE);

    // IĂяȍꍇ͂̃Xe[^XŕԂ
    // ͂u܂ȂvƂoŎg
    return STATUS_MORE_PROCESSING_REQUIRED;
}

NTSTATUS USB_StartDevice(IN PDEVICE_OBJECT DeviceObject)
{
    NTSTATUS ntStatus;
    IN ULONG configurationDescriptorSize;
    PUSB_CONFIGURATION_DESCRIPTOR configurationDescriptor = 
					NULL;
    PDEVICE_EXTENSION deviceExtension;

    USB_KdPrint (("I'm USB_StartDevice.\n"));

    // oX̃CtH[V擾
    USB_GetBusInterface(DeviceObject);
    
	deviceExtension = DeviceObject->DeviceExtension;

    // ----- RtBM[V̑Sf[^m邽߂-----
    // ----- ܂̓RtBM[VfBXNv^݂̂擾 -----

    configurationDescriptorSize = 
					sizeof(USB_CONFIGURATION_DESCRIPTOR);
    configurationDescriptor = ExAllocatePool(
                        NonPagedPool, 
                    configurationDescriptorSize+1);

    ntStatus = USB_GetConfigurationDescriptor(
                    DeviceObject,
                    configurationDescriptorSize,
                    configurationDescriptor
                );
    if ( !NT_SUCCESS(ntStatus) )
        goto USB_StartDeviceExit;

    // ----- ɑSRtBM[Vf[^擾-----

    // RtBM[VfBXNv^wTotalLengthݒ肷
    // ȂC擾RtBM[VfBXNv^
    // DEVICE_EXTENSION\̂ɂ̂ŁCłQƂł
    deviceExtension->TotalConfigDescriptorLength
        = (ULONG)configurationDescriptor->wTotalLength;
    ExFreePool(configurationDescriptor);
    deviceExtension->ConfigurationAllDescriptor
        = ExAllocatePool(
            NonPagedPool,
            deviceExtension->TotalConfigDescriptorLength+1);

    ntStatus = USB_GetConfigurationDescriptor(
                    DeviceObject,
                    deviceExtension->
							TotalConfigDescriptorLength,
                    deviceExtension->ConfigurationAllDescriptor
                );
    if ( !NT_SUCCESS(ntStatus) )
        goto USB_StartDeviceExit;

    USB_KdPrint (("USB_StartDevice Get ConfigAllDescriptor Length = %d\n",
        deviceExtension->TotalConfigDescriptorLength));

    // 擾RtBM[Vf[^Ƃ
    // RtBM[VsāCI
    ntStatus = USB_CreateConfiguration(DeviceObject,
               deviceExtension->ConfigurationAllDescriptor);

USB_StartDeviceExit:

    USB_KdPrint (("Exit USB_StartDevice ntStatus = %x\n",
        ntStatus));

    return ntStatus;
}

NTSTATUS USB_GetConfigurationDescriptor(
    IN PDEVICE_OBJECT DeviceObject,
    IN ULONG configurationDescriptorSize,
    IN PUSB_CONFIGURATION_DESCRIPTOR configurationDescriptor
)
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus;
    PURB urb = NULL;

    USB_KdPrint (("I'm USB_GetConfigurationDescriptor.\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    // GET_CONFIGURATION_DESCRIPTOR𔭍s邽߂URBmۂ
    urb = ExAllocatePool(NonPagedPool,
        sizeof(struct _URB_CONTROL_DESCRIPTOR_REQUEST));

    // GET_CONFIGURATION_DESCRIPTOR𔭍s邽߂URB쐬
    UsbBuildGetDescriptorRequest(urb,
        (USHORT) sizeof (struct 
							_URB_CONTROL_DESCRIPTOR_REQUEST),
        USB_CONFIGURATION_DESCRIPTOR_TYPE,
        0,
        0,
        configurationDescriptor,
        NULL,
        configurationDescriptorSize,
        NULL);

    // GET_CONFIGURATION_DESCRIPTOR𔭍s
    ntStatus = USB_CallUSBD(DeviceObject, urb);

    if (urb)
        ExFreePool(urb);

    return ntStatus;
}

NTSTATUS USB_CreateConfiguration(
    IN PDEVICE_OBJECT                DeviceObject,
    IN PUSB_CONFIGURATION_DESCRIPTOR ConfigurationDescriptor
    )
{
#define USB_STORAGE_CLASS_CODE 8
    PDEVICE_EXTENSION           deviceExtension;
    NTSTATUS                    ntStatus;
    PURB                        urb = NULL;
    ULONG                       i, dir;
    PUSB_INTERFACE_DESCRIPTOR   interfaceDescriptor;
    PUSBD_INTERFACE_INFORMATION Interface;
    PUSBD_INTERFACE_LIST_ENTRY 
							interfaceList,topOfInterfaceList;

    USB_KdPrint (("I'm USB_SelectConfiguration.\n"));

    // SELECT_CONFIGURATION
    // ̃foCXhCo̓C^[tF[X
    // 1̃foCXT|[gĂ

    deviceExtension = DeviceObject->DeviceExtension;

    // C^[tF[XiWDMŊǗjXg擾
    // 2mۂĂ̂́C2ڂĨ}[LOƂĎg߂ł

    topOfInterfaceList =interfaceList
        = ExAllocatePool(NonPagedPool,sizeof
							(USBD_INTERFACE_LIST_ENTRY) * 2);
    if(!interfaceList) {
        ntStatus = STATUS_NO_MEMORY;
        goto USB_CreateConfigurationExit;
    }

    // C^[tF[XfBXNv^擾
    interfaceDescriptor =
        USBD_ParseConfigurationDescriptorEx(
            ConfigurationDescriptor,
            ConfigurationDescriptor,
            //T[`ŏ̃RtBM[VfBXNv^
            -1,                        // interface number
            -1,                        // alternate setting
            USB_STORAGE_CLASS_CODE,    // interface class
            -1,                        // interface subclass
            -1 );                      // interface protocol

    // C^[tF[XXgXV
    interfaceList->InterfaceDescriptor = interfaceDescriptor;
    interfaceList->Interface = NULL;

    // C^[tF[X1ŏI
    interfaceList++;
    interfaceList->InterfaceDescriptor = NULL;
    interfaceList->Interface = NULL;

    // SelectConfiguration̂߂URBmۂ
    // Kvȃf[^tH[}bg
    urb = USBD_CreateConfigurationRequestEx(
            ConfigurationDescriptor, topOfInterfaceList);

    // USBD_ParseConfigurationDescriptorExŐݒ肳ꂽ
    // C^[tF[XiWDMǗj擾
    Interface = &urb->UrbSelectConfiguration.Interface;

    // pCv̍ő]TCYCʂɑOɂ炩ߐݒ肵Ă
    // {foCXhCoł́C64KB܂ňCɓ]ł悤ɂ
    for (i = 0; i < Interface->NumberOfPipes; i++) {
        Interface->Pipes[i].MaximumTransferSize = 65536;
    }

    // ZNgRtBM[Vs
    ntStatus = USB_CallUSBD(DeviceObject, urb);

    // ZNgRtBM[V͐H
    if (NT_SUCCESS(ntStatus)) {

        // ̂ŁCUSBf[^\
        USB_KdPrint (("USB_CreateConfiguration Success! ---------- \n"));
        USB_KdPrint (("Class, subclass, protocol 0x%x 0x%x 0x%x\n",
            Interface->Class,
            Interface->SubClass,
            Interface->Protocol));
        for (i = 0; i < Interface->NumberOfPipes; i++) {
            int dir;

            USB_KdPrint (("Endpoint[Addr:%02x] Type %x MaxPacketSize %d \n",
                Interface->Pipes[i].EndpointAddress,
                Interface->Pipes[i].PipeType,
                Interface->Pipes[i].MaximumPacketSize));

            // oNIN/OUT̃pCvCtH[V
            // DEVICE_EXTENSIONɃāCg悤ɂ
            if (Interface->Pipes[i].PipeType == UsbdPipeTypeBulk) {               
					dir = (USBD_PIPE_DIRECTION_IN(&Interface->Pipes[i])) ?
								USBD_TRANSFER_DIRECTION_IN :
									 USBD_TRANSFER_DIRECTION_OUT;
                deviceExtension->BulkPipeInformation[dir] = 
										Interface->Pipes[i];
            }
        }
        USB_KdPrint (("-----------------------------\n"));
    }

USB_CreateConfigurationExit:

    // mۂ̉
    if (topOfInterfaceList)
        ExFreePool(topOfInterfaceList);

    if (urb)
        ExFreePool(urb);

    return ntStatus;
}

VOID USB_GetBusInterface(IN PDEVICE_OBJECT DeviceObject)
{
    PIRP			irp;
    KEVENT		event;
    NTSTATUS	ntStatus;
    PDEVICE_EXTENSION		deviceExtension;
    PIO_STACK_LOCATION		nextStack;

    deviceExtension = (PDEVICE_EXTENSION) DeviceObject->
					DeviceExtension;

    USB_KdPrint (("Enter USB_GetBusInterface \n"));

    // OSWindows XPȍ~ǂׂ
    deviceExtension->isWindowsXPSupport =
        IoIsWdmVersionAvailable(
            WDM_MAJOR_VERSION,
            WINDOWS_XP_FUNCTION_SUPPORT_VALUE);

    if (!deviceExtension->isWindowsXPSupport) {
        USB_KdPrint (("This OS is older than Windows XP.\n"));
        return ;
    }
#if DBG 	// \Ȃ̂ŁCReleaseɂ͕sv
    else {
        USB_KdPrint (("This OS is Windows XP or later \n"));
    }
#endif

    // USBoXCtH[VmۗpIRPmۂ
    irp = IoAllocateIrp(deviceExtension->StackDeviceObject->
					StackSize,FALSE);

    // IRPIʒm̃Cxg쐬
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // IRPoXfoCXhCo
    // IrpCompleteEventSetĂŃCxg
    // ݒ肵Ă炤
    IoSetCompletionRoutine(irp,
                           IrpCompleteEventSet,
                           &event,
                           TRUE,
                           TRUE,
                           TRUE
                           );

    // ʃhCoI/OX^bNP[Vmۂď
    nextStack = IoGetNextIrpStackLocation(irp);
    ASSERT(nextStack);
    nextStack->MajorFunction = IRP_MJ_PNP;
    nextStack->MinorFunction = IRP_MN_QUERY_INTERFACE;

    // oXC^[tF[X̃f[^DEVICE_EXTENSIONɊmۂ
    nextStack->Parameters.QueryInterface.Interface =
        (PINTERFACE) &deviceExtension->UsbBusInterfaceUSBD;

    // C^[tF[Xdlf[^͕sv
    nextStack->Parameters.QueryInterface.
							InterfaceSpecificData = NULL;

    // USBDoXfoCXhCoGUIDݒ肷
    nextStack->Parameters.QueryInterface.InterfaceType =
                            &USB_BUS_INTERFACE_USBDI_GUID;

    // oXC^[tF[X̃TCYݒ肷
    nextStack->Parameters.QueryInterface.Size =
                         sizeof(USB_BUS_INTERFACE_USBDI_V1);

    // oXC^[tF[X̃o[W1(Xg3-19)w肷
    nextStack->Parameters.QueryInterface.Version = 
					USB_BUSIF_USBDI_VERSION_1;

    // ʂ̃oXfoCXhCoɏ˗CI҂
    ntStatus = IoCallDriver(DeviceObject,irp);
    if(STATUS_PENDING == ntStatus) {
        KeWaitForSingleObject(&event,
                              Executive,
                              KernelMode,
                              FALSE,
                              NULL);
        ntStatus = irp->IoStatus.Status;
    }

    IoFreeIrp(irp);
}

NTSTATUS USB_CallUSBD(
    IN PDEVICE_OBJECT DeviceObject,
    IN PURB Urb
    )
{
    NTSTATUS ntStatus, status = STATUS_SUCCESS;
    PDEVICE_EXTENSION deviceExtension;
    PIRP irp;
    KEVENT event;
    IO_STATUS_BLOCK ioStatus;
    PIO_STACK_LOCATION nextStack;

    // URBʂ̃foCXhCoɑď˗
    // ICxgő҂
    // deviceExtensionɂUSBoXfoCXhCõIuWFNg
    // ̂ƂiAddDeviceɐݒ肳ĂƉ肷j
    deviceExtension = DeviceObject->DeviceExtension;

    // ʃfoCXhCȍ҂Cxg̏
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // IOCTL_INTERNAL_USB_SUBMIT_URBvsIRP쐬
    irp = IoBuildDeviceIoControlRequest(
                IOCTL_INTERNAL_USB_SUBMIT_URB,
                deviceExtension->StackDeviceObject,
                NULL,
                0,
                NULL,
                0,
                TRUE, // IRP_MJ_INTERNAL_DEVICE_CONTROLw
                &event,
                &ioStatus);

    // ʃhCoI/OX^bNP[V擾
    nextStack = IoGetNextIrpStackLocation(irp);

    // p[^URBw肷
    nextStack->Parameters.Others.Argument1 = Urb;

    // ʃfoCXhCoioXfoCXhCojɏ˗
    ntStatus = IoCallDriver(deviceExtension->StackDeviceObject,
                            irp);

    // ICxgő҂
    if (ntStatus == STATUS_PENDING)
    {
        ntStatus = KeWaitForSingleObject(
                        &event,
                        Executive,
                        KernelMode,
                        FALSE,
                        NULL);
    }
    else {
        ioStatus.Status = ntStatus;
    }
    ntStatus = ioStatus.Status;

    return ntStatus;
}

// ---------- IRP_MJ_POWER ----------

NTSTATUS
USB_DispatchPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus;
    PIO_STACK_LOCATION  irpStack;

    deviceExtension = DeviceObject->DeviceExtension;
    irpStack = IoGetCurrentIrpStackLocation (Irp);

    USB_KdPrint (("Hello World I'm USB_DispatchPower func %x\n",
        irpStack->MinorFunction));

    // d͊Ǘ̊e͂̂悤ɗv
    switch (irpStack->MinorFunction) {

    case IRP_MN_SET_POWER:

        // ----------- p[ɂ ----------
        // ́Ct@NVfoCXhCo̗ł
        // foCXp[ɂẮCoXfoCXhCo
        // CāCVXep[ɑΉR[hɂȂĂ
        switch (irpStack->Parameters.Power.Type) {

        case SystemPowerState:
        // VXep[USBt@NVfoCXhCoŖʓ|
        return SystemSetPower(DeviceObject,Irp);

        case DevicePowerState:
            //\ďI
            USB_KdPrint (("DevicePowerState PowerState=%x \n",irpStack->Parameters.Power.State ));
            break;
        }

        break;

    case IRP_MN_QUERY_POWER:

        switch (irpStack->Parameters.Power.Type) {

        case SystemPowerState:
        // VXep[ύXĂ悢₢킹Ă
        // KvȂ΂ɏ
        break;

        case DevicePowerState:
        // foCXp[ύXĂ悢₢킹Ă
        // KvȂ΂ɏ

        break;

        }
        break;

    default:
        break;

    }

    // ʃfoCXhCoɏۓĂ
    // d͊Ǘsꍇ́CȉR[ĥ悤
    // PoStartNextPowerIrpCPoCallDriverƂ
    // Po?????Ƃ`APIg
    PoStartNextPowerIrp( Irp);
    IoSkipCurrentIrpStackLocation(Irp);

    ntStatus = PoCallDriver (deviceExtension->StackDeviceObject, Irp);

    return ntStatus;
}

NTSTATUS SystemSetPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    NTSTATUS								ntStatus;
    POWER_STATE							powerState;
    PDEVICE_EXTENSION					deviceExtension;
    PIO_STACK_LOCATION				irpStack;
    SYSTEM_POWER_STATE				systemState;
    DEVICE_POWER_STATE				deviceState;
    PPOWER_COMPLETION_CONTEXT	powerContext;

    deviceExtension = (PDEVICE_EXTENSION)DeviceObject->
							DeviceExtension;
    irpStack = IoGetCurrentIrpStackLocation(Irp);

    // VXeXe[^X擾
    systemState = irpStack->Parameters.Power.State.
							SystemState;

    // J[lݒ肵VXep[Xe[gɑΉ
    // foCXXe[gݒ肷ɂ́CɓK؂Ȓl
    deviceState = deviceExtension->
						DeviceCapabilities.DeviceState[systemState];
    powerState.DeviceState = deviceState;

    USB_KdPrint (("SystemSetPower set DeviceState %x\n",deviceState));

    // p[䊮֐̃p[^mۂāCꂼݒ肷
    powerContext = (PPOWER_COMPLETION_CONTEXT)
                   ExAllocatePool(NonPagedPool,
                         sizeof(POWER_COMPLETION_CONTEXT));
    powerContext->DeviceObject = DeviceObject;
    powerContext->Irp = Irp;

    // foCX̃p[Zbg𔭍s
    // ICDevicePowerSetComplete֐Ă΂
    ntStatus = PoRequestPowerIrp(
        deviceExtension->PhysicalDeviceObject,
        irpStack->MinorFunction,
        powerState, 	// foCXp[Xe[gXVĂ
        (PREQUEST_POWER_COMPLETE)DevicePowerSetComplete,
        powerContext,
        NULL);

    if(NT_SUCCESS(ntStatus))
        return ntStatus; 	// ȂΏI

    // sꍇ́C̃p[}l[WgIRP

    PoStartNextPowerIrp(Irp);
    Irp->IoStatus.Status = ntStatus;
    Irp->IoStatus.Information = 0;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    if(powerContext) {
        ExFreePool(powerContext);
    }

    return ntStatus;
}


VOID DevicePowerSetComplete(
    IN PDEVICE_OBJECT DeviceObject,
    IN UCHAR MinorFunction,
    IN POWER_STATE PowerState,
    IN PVOID Context,
    IN PIO_STATUS_BLOCK IoStatus
    )
{
    PIRP                      Irp;
    PDEVICE_EXTENSION         deviceExtension;
    PPOWER_COMPLETION_CONTEXT powerContext;

    powerContext = (PPOWER_COMPLETION_CONTEXT) Context;
    Irp = powerContext->Irp;
    deviceExtension = powerContext->DeviceObject->
							DeviceExtension;

    ExFreePool(powerContext);

    // ̃p[}l[WgIRP悤ɂ
    PoStartNextPowerIrp(Irp);
	IoSkipCurrentIrpStackLocation(Irp);

    // ʃfoCXhCoIRP𓊂邱ƂŁC
    // VXep[Xe[gI
    PoCallDriver (deviceExtension->StackDeviceObject, Irp);

    USB_KdPrint (("enter DevicePowerSetComplete st %x \n",
        Irp->IoStatus.Status));
}

// ---------- IRP_MJ_CREATE ----------

NTSTATUS USB_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    PFILE_OBJECT	fileObject;
    PIO_STACK_LOCATION		irpStack;
    NTSTATUS	ntStatus = STATUS_SUCCESS;

    USB_KdPrint (("Hello World I'm USB_Create \n"));

    irpStack = IoGetCurrentIrpStackLocation(Irp);


    // t@CIuWFNg擾
    fileObject = irpStack->FileObject;
    if(!fileObject) {
        ntStatus = STATUS_INVALID_PARAMETER;
        goto USB_CreateExit;
    }


#if DBG  // \Ȃ̂ŁCfobOɂ̂ݑ݂R[hɂ

    // t@Cl[Ύo
    if(fileObject->FileName.Length) {
        // t@Cl[́CUNICODEƂCWindowsł

        // Ȃ݂2oCg1ƂR[h
        // ŝŁCWCHARC܂2Ŋ
        PUNICODE_STRING FileName = &fileObject->FileName;
        ULONG nameLength = (FileName->Length / sizeof(WCHAR));

		USB_KdPrint(("Filename = %ws nameLength = %d\n", FileName->Buffer, nameLength));
    }

#endif

USB_CreateExit:

    // t@CIuWFNgCreate

    Irp->IoStatus.Status = ntStatus;
    Irp->IoStatus.Information = 0;

    IoCompleteRequest(Irp, IO_NO_INCREMENT);

    return ntStatus;

}


// ---------- IRP_MJ_CLOSE ----------
NTSTATUS USB_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_Close \n"));

    // IRP𐬌Ŋ
    Irp->IoStatus.Status = STATUS_SUCCESS;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);
    return STATUS_SUCCESS;
}

// ---------- IRP_MJ_DEVICE_CONTROL ---------
NTSTATUS USB_ProcessIOCTL(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp
    )
{
    NTSTATUS            ntStatus;
    PIO_STACK_LOCATION  irpStack;
    PDEVICE_EXTENSION   deviceExtension;
    PVOID               ioBuffer;
    ULONG               inputBufferLength, outputBufferLength;

    USB_KdPrint (("Hello World I'm USB_ProcessIOCTL \n"));

    deviceExtension     = DeviceObject->DeviceExtension;
    irpStack            = IoGetCurrentIrpStackLocation (Irp);

    // obt@[hI/Õobt@擾
    ioBuffer		= Irp->AssociatedIrp.SystemBuffer;
    inputBufferLength	= irpStack->
					Parameters.DeviceIoControl.InputBufferLength;
    outputBufferLength	= irpStack->
					Parameters.DeviceIoControl.OutputBufferLength;

    // R[hɉďU蕪
    switch (irpStack->Parameters.DeviceIoControl.
					IoControlCode) {

    case IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR:

        // foCXɎ擾RtBM[VfBXNv^
        // VXeobt@ɃRs[
        RtlCopyMemory(
            ioBuffer,
            deviceExtension->ConfigurationAllDescriptor,
            deviceExtension->TotalConfigDescriptorLength);

        // obt@ɃRs[ݒ肵Ă
        Irp->IoStatus.Information =
            deviceExtension->TotalConfigDescriptorLength;
        ntStatus = STATUS_SUCCESS;

        USB_KdPrint (("IOCTL_USB_GET_CONFIGURATION_DESCRIPTOR size=%d\n",deviceExtension->TotalConfigDescriptorLength));

        break;

    case IOCTL_USB_CLASS_REQUEST:
        ntStatus = USB_ClassRequest(DeviceObject, ioBuffer, 
					&inputBufferLength);
        Irp->IoStatus.Information = inputBufferLength;
        break;
    
    case IOCTL_USB_RESET_PIPE:
        ntStatus = USB_ResetPipe(DeviceObject);
        Irp->IoStatus.Information = 0; // f[^̑M͂Ȃ
        break;

    case IOCTL_USB_CHECK_SPEED:
        if (deviceExtension->isWindowsXPSupport)
        {
            // USBoXCtH[VIsDeviceHighSpeed 
            // gāCUSB2.0foCXۂmF
            // ʂLONGϐ(4oCgf[^)ŉ

            USB_BUS_INTERFACE_USBDI_V1 *UsbBusInformationUSBD;
            ULONG *IsDeviceHighSpeed = (ULONG *)ioBuffer;

            UsbBusInformationUSBD =
                    &deviceExtension->UsbBusInterfaceUSBD;

            *IsDeviceHighSpeed =
                UsbBusInformationUSBD->IsDeviceHighSpeed(
                    UsbBusInformationUSBD->BusContext);

            USB_KdPrint(("IsDeviceHighSpeed = %x\n", 
							*IsDeviceHighSpeed));

            ntStatus = STATUS_SUCCESS;

            Irp->IoStatus.Information = sizeof(ULONG);
            Irp->IoStatus.Status = STATUS_SUCCESS;

            break;
        }
        else {
            //WindowsÂăT|[gĂȂ
            ntStatus = STATUS_NOT_SUPPORTED;
            Irp->IoStatus.Information = sizeof(ULONG);
            Irp->IoStatus.Status = STATUS_SUCCESS;
        }

	default:
        ntStatus = STATUS_INVALID_PARAMETER;
    }

    // IRP̊
    Irp->IoStatus.Status = ntStatus;
    IoCompleteRequest (Irp, IO_NO_INCREMENT);
    USB_KdPrint (("Exit USB_ProcessIOCTL status %x\n", 
					ntStatus));

    return ntStatus;
}

NTSTATUS USB_ClassRequest(
    PDEVICE_OBJECT DeviceObject,
    PCHAR   pBuffer,
    PULONG length
    )
{
    NTSTATUS        ntStatus;
    URB             urb;

    // NXNGXgsURB쐬
    UsbBuildVendorRequest(  &urb, URB_FUNCTION_CLASS_INTERFACE,
        (USHORT)sizeof(struct 
							_URB_CONTROL_VENDOR_OR_CLASS_REQUEST),
        0,		// ULONG    transferFlags
        0,		// UCHAR    reservedbits
        0,		// UCHAR    request
        0,		// USHORT   value
        0,		// USHORT   index
        pBuffer,		// IN PVOID TransferBuffer
        NULL,		// IN PMDL TransferBufferMDL
        *length,		// IN ULONG TransferBufferLength,
        NULL );		// IN PURB Link )

    // NXNGXg𔭍sāC]f[^ݒ肷
    ntStatus = USB_CallUSBD(DeviceObject, &urb);
    if (NT_SUCCESS(ntStatus)) {
        *length = urb.UrbControlVendorClassRequest.
							TransferBufferLength;
    } else {
        *length = 0;
    }

    USB_KdPrint (("USB_ClassRequest urb.status %x\n", 
				urb.UrbHeader.Status));

    return(urb.UrbHeader.Status);
}

NTSTATUS
USB_ResetPipe(
    PDEVICE_OBJECT DeviceObject
)
{
    NTSTATUS                ntStatus;
    URB                     urb;
    PUSBD_PIPE_INFORMATION  pipeInformation;
    PDEVICE_EXTENSION       deviceExtension;

    deviceExtension = DeviceObject->DeviceExtension;
    pipeInformation = deviceExtension->NeedResetPipe;
    if (pipeInformation == NULL)
        return STATUS_SUCCESS; 	// ZbgׂpCv͂Ȃ

    // pCvZbgŝŁCURBɂݒ肷
    urb.UrbHeader.Length		= (USHORT) sizeof(struct 
					_URB_PIPE_REQUEST);
    urb.UrbHeader.Function		= URB_FUNCTION_RESET_PIPE;
    urb.UrbPipeRequest.PipeHandle	= pipeInformation->PipeHandle;

    // pCvZbgʃfoCXhCoɈ˗
    ntStatus = USB_CallUSBD(DeviceObject, &urb);
    if (NT_SUCCESS(ntStatus))
        deviceExtension->NeedResetPipe = NULL;

    USB_KdPrint(("USB_ResetPipe urb.status %x \n",urb.UrbHeader.Status));

    return (urb.UrbHeader.Status);
}

// ---------- IRP_MJ_READ -----------
// ---------- IRP_MJ_WRITE ----------

NTSTATUS USB_BulkReadWrite(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    PURB	urb;
    ULONG	transferLength;
    NTSTATUS	ntStatus;
    PDEVICE_EXTENSION	deviceExtension;
    PBULK_RW_CONTEXT	rwContext;
    PUSBD_PIPE_INFORMATION	pipeInformation;

    USB_KdPrint (("Hello World I'm USB_BulkReadWrite \n"));

    transferLength = 0;
    deviceExtension = (PDEVICE_EXTENSION) DeviceObject->
							DeviceExtension;
    // iMDL̃p[^jf[^]擾
    if(Irp->MdlAddress) {
        transferLength = MmGetMdlByteCount(Irp->MdlAddress);
    }
    if(!transferLength) {
        USB_KdPrint(("Transfer data length = 0\n"));
        ntStatus = STATUS_SUCCESS;
        goto USB_BulkReadWrite_Exit;
    }

    // oN]pURBmۂCpCv擾
    urb = USB_GetBulkTransferUrb(deviceExtension,Irp,
            transferLength,Irp->MdlAddress,&pipeInformation);
    if(urb == NULL) {
        USB_KdPrint(("Failed to alloc memory for urb\n"));
        ntStatus = STATUS_INSUFFICIENT_RESOURCES;
        goto USB_BulkReadWrite_Exit;
    }

    // ɌĂяo֐̃p[^f[^mۂ
    rwContext = (PBULK_RW_CONTEXT)ExAllocatePool(NonPagedPool,
                                  sizeof(BULK_RW_CONTEXT));
    if(rwContext == NULL) {
        USB_KdPrint(("Failed to alloc memory for rwContext\n"));
        ntStatus = STATUS_INSUFFICIENT_RESOURCES;
        goto USB_BulkReadWrite_Exit;
    }

    // [`ɓnp[^ݒ肷
    rwContext->Urb             = urb;
    rwContext->deviceExtension = deviceExtension;
    rwContext->pipeInformation = pipeInformation;

    // USBzXgRg[hCoɏ˗
    IoMarkIrpPending(Irp);
    ntStatus = USB_IoCallDriverToTransferBulkData
							(Irp,rwContext);
    if(!NT_SUCCESS(ntStatus)) {
        USB_KdPrint(("IoCallDriver fails with status %X\n", 
							ntStatus));
        goto USB_BulkReadWrite_Exit;
    }

    // oXfoCXhCȍ҂
    return STATUS_PENDING;

USB_BulkReadWrite_Exit: 	// G[

    if (rwContext) ExFreePool(rwContext);
    if (urb) ExFreePool(urb);

    Irp->IoStatus.Status = ntStatus;
    Irp->IoStatus.Information = 0;
    IoCompleteRequest(Irp, IO_NO_INCREMENT);
    USB_KdPrint(("USB_BulkReadWrite error (st %x) \n",ntStatus));

    return ntStatus;
}

NTSTATUS
USB_BulkCompletion(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp,
    IN PVOID          Context
    )
{
    // [h/Cg

    ULONG	stageLength;
    NTSTATUS	ntStatus;
    PBULK_RW_CONTEXT	rwContext;
    PDEVICE_EXTENSION	deviceExtension;
    PURB	urb;

    // p[^𕜌
    rwContext = (PBULK_RW_CONTEXT) Context;
    deviceExtension = rwContext->deviceExtension;
    urb = rwContext->Urb;

    ntStatus = Irp->IoStatus.Status;

    USB_KdPrint(("enter USB_BulkCompletion st %x transferLength %d \n",
        ntStatus,urb->UrbBulkOrInterruptTransfer.
							TransferBufferLength));

    // ]߂lɎw肷
    Irp->IoStatus.Information = urb->
				UrbBulkOrInterruptTransfer.TransferBufferLength;

    if (USBD_HALTED(urb->UrbHeader.Status)) {	 // STALLǂ

        // STALLɂȂGh|CgpCv̓Zbg
        // KvɂȂ̂ŁCŊoĂ
        deviceExtension->NeedResetPipe = rwContext->
							pipeInformation;

        Irp->IoStatus.Information = 0;
        USB_KdPrint(("ReadWriteCompletion -	failed with status = %X\n",
            urb->UrbHeader.Status));
    }

    // mۂĂ
    if (rwContext->Urb)
        ExFreePool(rwContext->Urb);
    if (rwContext)
        ExFreePool(rwContext);

    return STATUS_SUCCESS;
}


PURB USB_GetBulkTransferUrb (
    IN PDEVICE_EXTENSION deviceExtension,
    IN PIRP  Irp,
    IN ULONG transferLength,
    IN PMDL  mdl,
    OUT PUSBD_PIPE_INFORMATION *pipeInformation
    )
{
    // oN]URBݒ肵Ė߂lƂ

#define PipeMaximumTransferSize \
    ((PUSBD_PIPE_INFORMATION)*pipeInformation)->MaximumTransferSize

    PIO_STACK_LOCATION		irpStack;
    PURB	urb;
    ULONG	urbFlags;
    BOOLEAN	read;
    ULONG	urbTransferSize = transferLength;

    irpStack = IoGetCurrentIrpStackLocation(Irp);
    read = (irpStack->MajorFunction == IRP_MJ_READ) ?
							 TRUE : FALSE;

    // URBmۂ

    urb = ExAllocatePool(NonPagedPool,
           sizeof(struct _URB_BULK_OR_INTERRUPT_TRANSFER));
    if(!urb) {
        USB_KdPrint(("Failed to alloc memory for urb\n"));
        return NULL;
    }

    // gpGh|Cg肵ČĂяoɒʒm
    *pipeInformation
        = &deviceExtension->BulkPipeInformation[
            (read) ? \
                USBD_TRANSFER_DIRECTION_IN : 
								USBD_TRANSFER_DIRECTION_OUT ];
    if (transferLength > PipeMaximumTransferSize) {
        //Gh|Cg̍ő]傫
        //Gh|Cg̍ő]ɍ킹
        urbTransferSize = PipeMaximumTransferSize;
    }

    // USBoN]̃tOݒ肷
    urbFlags = USBD_SHORT_TRANSFER_OK;
    if(read) {
       urbFlags |= USBD_TRANSFER_DIRECTION_IN;
       USB_KdPrint(("Read operation\n"));
    }
    else {
       urbFlags |= USBD_TRANSFER_DIRECTION_OUT;
       USB_KdPrint(("Write operation\n"));
    }

    // oN]URB̍쐬
    UsbBuildInterruptOrBulkTransferRequest(
                    urb,
                    sizeof(struct _URB_BULK_OR_INTERRUPT_TRANSFER),
                    ((PUSBD_PIPE_INFORMATION)*pipeInformation)->PipeHandle,
                    NULL,
                    mdl,
                    urbTransferSize,
                    urbFlags,
                    NULL);

    USB_KdPrint(("USB_GetBulkTransferUrb transferLength %d \n",transferLength));

    return urb;
}

NTSTATUS USB_IoCallDriverToTransferBulkData(
    IN PIRP Irp,
    IN PBULK_RW_CONTEXT rwContext
    )
{
    PIO_STACK_LOCATION  nextStack;

    // ʃfoCXhCoI/OX^bNP[VmۂāC
    // ʃfoCXhCoɈ˗

    USB_KdPrint(("USB_IoCallDriverToTransferBulkData \n"));

    nextStack = IoGetNextIrpStackLocation(Irp);
    nextStack->MajorFunction = IRP_MJ_INTERNAL_DEVICE_CONTROL;
    nextStack->Parameters.Others.Argument1 = rwContext->Urb;
    nextStack->Parameters.DeviceIoControl.IoControlCode =
        IOCTL_INTERNAL_USB_SUBMIT_URB;

    IoSetCompletionRoutine(Irp,
        USB_BulkCompletion,
        rwContext,
        TRUE,
        TRUE,
        TRUE);

    return IoCallDriver(
        rwContext->deviceExtension->StackDeviceObject,Irp);
}

// EOF
