// usbtest.c
// USBXg[WfoCXeXgpfoCXhCo
// (C) 2003 Kenichiro Hamada

#define DRIVER

#include "usbtest.h"

// ---------- DriverEntry ----------

NTSTATUS
DriverEntry(
    IN PDRIVER_OBJECT DriverObject,
    IN PUNICODE_STRING RegistryPath
    )
{

    USB_KdPrint (("Hello World I'm DriverEntry \n"));

   // e̊֐o^
    DriverObject->DriverExtension->AddDevice			= USB_PnPAddDevice;
    DriverObject->DriverUnload								= USB_Unload;
    DriverObject->MajorFunction[IRP_MJ_PNP]				= USB_DispatchPnp;
    DriverObject->MajorFunction[IRP_MJ_POWER]			= USB_DispatchPower;
    DriverObject->MajorFunction[IRP_MJ_CREATE]			= USB_Create;
    DriverObject->MajorFunction[IRP_MJ_CLOSE]			= USB_Close;
    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL]	= USB_ProcessIOCTL;
    DriverObject->MajorFunction[IRP_MJ_READ]			= USB_BulkReadWrite;	
    DriverObject->MajorFunction[IRP_MJ_WRITE]			= USB_BulkReadWrite;

    return STATUS_SUCCESS;
}

// ---------- AddDevice ----------

NTSTATUS
USB_PnPAddDevice(
    IN PDRIVER_OBJECT DriverObject,
    IN PDEVICE_OBJECT PhysicalDeviceObject
    )
{
    NTSTATUS                ntStatus = STATUS_SUCCESS;
    PDEVICE_OBJECT          deviceObject = NULL;
    PDEVICE_EXTENSION       deviceExtension;

    USB_KdPrint (("Hello World I'm USB_PnPAddDevice \n"));


    // ̃foCX̃foCXIuWFNg쐬
    ntStatus = IoCreateDevice (DriverObject,
        sizeof (DEVICE_EXTENSION),
        NULL,
        FILE_DEVICE_UNKNOWN,
        0,
        FALSE,
        &deviceObject);

    if (ntStatus == STATUS_SUCCESS) {

        // foCXIuWFNg̍쐬ɐ

        // deviceExtension̓x_g|C^ł
        // ʏ́CDeviceɕKvɂȂǗC
        // DEVICE_EXTENSION\̂ɂĊǗ
        deviceExtension = deviceObject->DeviceExtension;

        // VC^[tF[Xo^
        // āC̃V{bNNij󂯎
        // ̃R[h́C炩DEVICE_EXTENSION\̂
        // SymbolicLinkName`Ă̂ƂĂ
        ntStatus = 
			IoRegisterDeviceInterface(PhysicalDeviceObject,
	            &USBTEST_GUID, NULL,
		        &deviceExtension->InterfaceSymbolicLinkName);
        if( ntStatus != STATUS_SUCCESS)
        {
            // GUIDo^ɎsȂ΁C쐬foCXIuWFNg
            // jāCI
            IoDeleteDevice(deviceObject);
            return ntStatus;
        }

        // o^C^[tF[XLɂāCAvP[V
        // foCXhCoɃANZXł悤ɂ
        IoSetDeviceInterfaceState(
            &deviceExtension->InterfaceSymbolicLinkName, TRUE);

        //@VLqD{hCoł̓f[^ʐM
        // _CNgI/OĝŁC錾Ă
        deviceObject->Flags |= DO_DIRECT_IO;


        // CjVCYÎŁCtÕCjVCY
        // قɃtOݒ肷ꍇ́CŋLqĂ
        deviceObject->Flags &= ~DO_DEVICE_INITIALIZING;

        // oXfoCXhCõfoCXIuWFNgǗ邽߂
        // DeviceExtensionɂ炩߂̃o[ݒ肵ĂāC
        // oXfoCXhCõfoCXIuWFNgRs[Ă
        deviceExtension->
							PhysicalDeviceObject=PhysicalDeviceObject;

        // IoAttachDeviceToDeviceStack֐ĂяoāCʂ̃foCX
        // hCõfoCXIuWFNgo
        // ɁCʂ̃foCXhCõfoCXIuWFNgǗ邽߂ɁC
        // DeviceExtensionɂ炩߂̃o[ݒ肵ĂāC
        // ʂ̃foCXhCõfoCXIuWFNgRs[Ă
        deviceExtension->StackDeviceObject =
            IoAttachDeviceToDeviceStack(deviceObject, 
							PhysicalDeviceObject);
   }

    DbgBreakPoint(); // ō폜DŎ~߂ċĂ݂

   return ntStatus;
}

// ---------- UnLoad ----------

VOID USB_Unload(IN PDRIVER_OBJECT DriverObject)
{
    USB_KdPrint (("Hello World I'm USB_Unload \n"));
}

// ---------- IRP_MJ_PNP ----------

NTSTATUS
USB_DispatchPnp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_DispatchPnp \n"));

    return STATUS_UNSUCCESSFUL;
}

// ---------- IRP_MJ_POWER ----------

NTSTATUS
USB_DispatchPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_DispatchPower \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_CREATE ----------

NTSTATUS USB_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_Create \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_CLOSE ----------

NTSTATUS USB_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_Close \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_DEVICE_CONTROL ---------

NTSTATUS USB_ProcessIOCTL(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_ProcessIOCTL \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_READ -----------
// ---------- IRP_MJ_WRITE ----------

NTSTATUS USB_BulkReadWrite(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_BulkReadWrite \n"));

    return STATUS_UNSUCCESSFUL;
}

// EOF
