// usbtest.c
// USBXg[WfoCXeXgpfoCXhCo
// (C) 2003 Kenichiro Hamada

#define DRIVER

#include "usbtest.h"

// ---------- DriverEntry ----------

NTSTATUS
DriverEntry(
    IN PDRIVER_OBJECT DriverObject,
    IN PUNICODE_STRING RegistryPath
    )
{

    USB_KdPrint (("Hello World I'm DriverEntry \n"));

    // e̊֐o^
    DriverObject->DriverExtension->AddDevice			= USB_PnPAddDevice;
    DriverObject->DriverUnload								= USB_Unload;
    DriverObject->MajorFunction[IRP_MJ_PNP]				= USB_DispatchPnp;
    DriverObject->MajorFunction[IRP_MJ_POWER]			= USB_DispatchPower;
    DriverObject->MajorFunction[IRP_MJ_CREATE]			= USB_Create;
    DriverObject->MajorFunction[IRP_MJ_CLOSE]			= USB_Close;
    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL]	= USB_ProcessIOCTL;
    DriverObject->MajorFunction[IRP_MJ_READ]			= USB_BulkReadWrite;	
    DriverObject->MajorFunction[IRP_MJ_WRITE]			= USB_BulkReadWrite;

    return STATUS_SUCCESS;
}

// ---------- AddDevice ----------

NTSTATUS
USB_PnPAddDevice(
    IN PDRIVER_OBJECT DriverObject,
    IN PDEVICE_OBJECT PhysicalDeviceObject
    )
{
    NTSTATUS                ntStatus = STATUS_SUCCESS;
    PDEVICE_OBJECT          deviceObject = NULL;
    PDEVICE_EXTENSION       deviceExtension;

    USB_KdPrint (("Hello World I'm USB_PnPAddDevice \n"));


    // ̃foCX̃foCXIuWFNg쐬
    ntStatus = IoCreateDevice (DriverObject,
        sizeof (DEVICE_EXTENSION),
        NULL,
        FILE_DEVICE_UNKNOWN,
        0,
        FALSE,
        &deviceObject);

    if (ntStatus == STATUS_SUCCESS) {

        // foCXIuWFNg̍쐬ɐ

        // deviceExtension̓x_g|C^ł
        // ʏ́CDeviceɕKvɂȂǗC
        // DEVICE_EXTENSION\̂ɂĊǗ
        deviceExtension = deviceObject->DeviceExtension;

        // VC^[tF[Xo^
        // āC̃V{bNNij󂯎
        // ̃R[h́C炩DEVICE_EXTENSION\̂
        // SymbolicLinkName`Ă̂ƂĂ
        ntStatus = 
			IoRegisterDeviceInterface(PhysicalDeviceObject,
	            &USBTEST_GUID, NULL,
		        &deviceExtension->InterfaceSymbolicLinkName);
        if( ntStatus != STATUS_SUCCESS)
        {
            // GUIDo^ɎsȂ΁C쐬foCXIuWFNg
            // jāCI
            IoDeleteDevice(deviceObject);
            return ntStatus;
        }

        // o^C^[tF[XLɂāCAvP[V
        // foCXhCoɃANZXł悤ɂ
        IoSetDeviceInterfaceState(
            &deviceExtension->InterfaceSymbolicLinkName, TRUE);

        //@VLqD{hCoł̓f[^ʐM
        // _CNgI/OĝŁC錾Ă
        deviceObject->Flags |= DO_DIRECT_IO;


        // CjVCYÎŁCtÕCjVCY
        // قɃtOݒ肷ꍇ́CŋLqĂ
        deviceObject->Flags &= ~DO_DEVICE_INITIALIZING;

        // oXfoCXhCõfoCXIuWFNgǗ邽߂
        // DeviceExtensionɂ炩߂̃o[ݒ肵ĂāC
        // oXfoCXhCõfoCXIuWFNgRs[Ă
        deviceExtension->
							PhysicalDeviceObject=PhysicalDeviceObject;

        // IoAttachDeviceToDeviceStack֐ĂяoāCʂ̃foCX
        // hCõfoCXIuWFNgo
        // ɁCʂ̃foCXhCõfoCXIuWFNgǗ邽߂ɁC
        // DeviceExtensionɂ炩߂̃o[ݒ肵ĂāC
        // ʂ̃foCXhCõfoCXIuWFNgRs[Ă
        deviceExtension->StackDeviceObject =
            IoAttachDeviceToDeviceStack(deviceObject, 
							PhysicalDeviceObject);
   }

   return ntStatus;
}

// ---------- UnLoad ----------

VOID USB_Unload(IN PDRIVER_OBJECT DriverObject)
{
    USB_KdPrint (("Hello World I'm USB_Unload \n"));
}

// ---------- IRP_MJ_PNP ----------

NTSTATUS
USB_DispatchPnp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    PIO_STACK_LOCATION  irpStack, nextStack;
    PDEVICE_EXTENSION   deviceExtension;
    NTSTATUS            ntStatus;
    BOOLEAN             DoPassToLowerDeviceDriver = TRUE;

    // ܂I/OX^bNP[Vl
    irpStack = IoGetCurrentIrpStackLocation (Irp);
    deviceExtension = DeviceObject->DeviceExtension;

    // ȏЉɃ}Ci[t@NVǉ
    USB_KdPrint (("Hello World I'm USB_DispatchPnp MinorFunc %02x\n",irpStack->MinorFunction));

    // }Ci[t@NVɏU蕪
    switch (irpStack->MinorFunction) {

    case IRP_MN_START_DEVICE:

        // ɉʃfoCXhCoɏ
        ntStatus = SendIrpSynchronously(deviceExtension->
							StackDeviceObject, Irp);
        if (ntStatus == STATUS_SUCCESS) {
            // ŃfoCXN̂
            // foCXȂǂ̏Lq
        }

        // ʃhCȍ͏IĂ̂
        // ʃfoCXhCȍ͍sȂ
        DoPassToLowerDeviceDriver = FALSE;

        break;

    case IRP_MN_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_REMOVE_DEVICE:

        ntStatus = SendIrpSynchronously(deviceExtension->
							StackDeviceObject, Irp);
        if (ntStatus == STATUS_SUCCESS) {
            // foCX폜ꂽꍇ
            // Kvȏ΂ɋLq
        }

        // foCX폜Ă̂ŁC
        // 쐬foCXIuWFNgȂǁCfoCX
        // ̃f[^鏈s

        // C^[tF[Xo^Ăꍇ́C폜
        IoSetDeviceInterfaceState(
            &deviceExtension->InterfaceSymbolicLinkName, 
							FALSE);
        RtlFreeUnicodeString(
            &deviceExtension->InterfaceSymbolicLinkName);

        // ʃfoCXhCofoCXIuWFNg
        // ؂藣āCKw\o^폜
        IoDetachDevice(deviceExtension->StackDeviceObject);

        // foCXIuWFNg폜
        IoDeleteDevice (DeviceObject);

        // ʃhCȍ͏IĂ̂
        // ʃfoCXhCȍ͍sȂ
        DoPassToLowerDeviceDriver = FALSE;

        break;

    case IRP_MN_QUERY_REMOVE_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_QUERY_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_CANCEL_REMOVE_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_CANCEL_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_SURPRISE_REMOVAL:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    default:
        // t@NVfoCXhCoȂ̂ŁC
        // ̂ق̃}Ci[R[h̓T|[gȂ 
        // ʂ̃foCXhCoɏC
        DoPassToLowerDeviceDriver = TRUE;
        break;

    } // switch MinorFunction

    if (DoPassToLowerDeviceDriver) {
        // ̊֐ŏȂꍇ́Cׂ
        // ʃfoCXhCoɂ̂܂ܗ
        // ŏĂ炤`ɂ
        IoSkipCurrentIrpStackLocation (Irp);
        ntStatus = IoCallDriver(
            deviceExtension->StackDeviceObject,Irp);
    }

    USB_KdPrint (("Exit USB_DispatchPnp ntStatus %x\n",ntStatus));


    return ntStatus;
}

NTSTATUS
SendIrpSynchronously (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    KEVENT   event;
    NTSTATUS status;

    USB_KdPrint (("I'm SendIrpSynchronously.\n"));

    // ʂ̃foCXhCoÎCxg
    // ҂̂ŁC̃Cxg
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // vOvCȂ̂ŁCI/OX^bN
    // P[VʃfoCXhCoI/OX^bN
    // P[VɃRs[
    IoCopyCurrentIrpStackLocationToNext(Irp);

    // ꍇɌĂяoė~֐o^
    // ̏ꍇ́CIrpCompleteEventSet֐ĂяoāC
    // ŃCxgݒ菈s
    IoSetCompletionRoutine(Irp,
                           IrpCompleteEventSet,
                           &event,
                           TRUE,
                           TRUE,
                           TRUE
                           );

    // ʂ̃foCXhCoĂяoāC
    // vOvC܂sĂ炤
    status = IoCallDriver(DeviceObject, Irp);

    // ʂ̃vOvCI܂ő҂
    // ̃CxǵCʃfoCXhCo
    // IƁCIrpCompleteEventSet֐
    // ɂĔƂ`ɂȂ
    if (status == STATUS_PENDING) {
        KeWaitForSingleObject(&event,
                             Executive,
                             KernelMode,
                             FALSE,
                             NULL
                             );
        status = Irp->IoStatus.Status;
    }

    return status;
}

NTSTATUS
IrpCompleteEventSet (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    )
{
    PKEVENT             event = (PKEVENT)Context;

    USB_KdPrint (("I'm IrpCompleteEventSet. \n"));

    // Cxgݒ肵āCCxg҂
    // KeWaitForSingleObject𔲂
    KeSetEvent (event, IO_NO_INCREMENT, FALSE);

    // IĂяȍꍇ͂̃Xe[^XŕԂ
    // ͂u܂ȂvƂoŎg
    return STATUS_MORE_PROCESSING_REQUIRED;
}

// ---------- IRP_MJ_POWER ----------

NTSTATUS
USB_DispatchPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_DispatchPower \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_CREATE ----------

NTSTATUS USB_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_Create \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_CLOSE ----------

NTSTATUS USB_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_Close \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_DEVICE_CONTROL ---------

NTSTATUS USB_ProcessIOCTL(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_ProcessIOCTL \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_READ -----------
// ---------- IRP_MJ_WRITE ----------

NTSTATUS USB_BulkReadWrite(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_BulkReadWrite \n"));

    return STATUS_UNSUCCESSFUL;
}

// EOF
