// usbtest.c
// USBXg[WfoCXeXgpfoCXhCo
// (C) 2003 Kenichiro Hamada

#define DRIVER

#include "usbtest.h"

// ---------- DriverEntry ----------

NTSTATUS
DriverEntry(
    IN PDRIVER_OBJECT DriverObject,
    IN PUNICODE_STRING RegistryPath
    )
{

    USB_KdPrint (("Hello World I'm DriverEntry \n"));

    // e̊֐o^
    DriverObject->DriverExtension->AddDevice			= USB_PnPAddDevice;
    DriverObject->DriverUnload								= USB_Unload;
    DriverObject->MajorFunction[IRP_MJ_PNP]				= USB_DispatchPnp;
    DriverObject->MajorFunction[IRP_MJ_POWER]			= USB_DispatchPower;
    DriverObject->MajorFunction[IRP_MJ_CREATE]			= USB_Create;
    DriverObject->MajorFunction[IRP_MJ_CLOSE]			= USB_Close;
    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL]	= USB_ProcessIOCTL;
    DriverObject->MajorFunction[IRP_MJ_READ]			= USB_BulkReadWrite;	
    DriverObject->MajorFunction[IRP_MJ_WRITE]			= USB_BulkReadWrite;

    return STATUS_SUCCESS;
}

// ---------- AddDevice ----------

NTSTATUS
USB_PnPAddDevice(
    IN PDRIVER_OBJECT DriverObject,
    IN PDEVICE_OBJECT PhysicalDeviceObject
    )
{
    NTSTATUS                ntStatus = STATUS_SUCCESS;
    PDEVICE_OBJECT          deviceObject = NULL;
    PDEVICE_EXTENSION       deviceExtension;

    USB_KdPrint (("Hello World I'm USB_PnPAddDevice \n"));


    // ̃foCX̃foCXIuWFNg쐬
    ntStatus = IoCreateDevice (DriverObject,
        sizeof (DEVICE_EXTENSION),
        NULL,
        FILE_DEVICE_UNKNOWN,
        0,
        FALSE,
        &deviceObject);

    if (ntStatus == STATUS_SUCCESS) {

        // foCXIuWFNg̍쐬ɐ

        // deviceExtension̓x_g|C^ł
        // ʏ́CDeviceɕKvɂȂǗC
        // DEVICE_EXTENSION\̂ɂĊǗ
        deviceExtension = deviceObject->DeviceExtension;

        // VC^[tF[Xo^
        // āC̃V{bNNij󂯎
        // ̃R[h́C炩DEVICE_EXTENSION\̂
        // SymbolicLinkName`Ă̂ƂĂ
        ntStatus = 
			IoRegisterDeviceInterface(PhysicalDeviceObject,
	            &USBTEST_GUID, NULL,
		        &deviceExtension->InterfaceSymbolicLinkName);
        if( ntStatus != STATUS_SUCCESS)
        {
            // GUIDo^ɎsȂ΁C쐬foCXIuWFNg
            // jāCI
            IoDeleteDevice(deviceObject);
            return ntStatus;
        }

        // o^C^[tF[XLɂāCAvP[V
        // foCXhCoɃANZXł悤ɂ
        IoSetDeviceInterfaceState(
            &deviceExtension->InterfaceSymbolicLinkName, TRUE);

        //@VLqD{hCoł̓f[^ʐM
        // _CNgI/OĝŁC錾Ă
        deviceObject->Flags |= DO_DIRECT_IO;


        // CjVCYÎŁCtÕCjVCY
        // قɃtOݒ肷ꍇ́CŋLqĂ
        deviceObject->Flags &= ~DO_DEVICE_INITIALIZING;

        // oXfoCXhCõfoCXIuWFNgǗ邽߂
        // DeviceExtensionɂ炩߂̃o[ݒ肵ĂāC
        // oXfoCXhCõfoCXIuWFNgRs[Ă
        deviceExtension->
							PhysicalDeviceObject=PhysicalDeviceObject;

        // IoAttachDeviceToDeviceStack֐ĂяoāCʂ̃foCX
        // hCõfoCXIuWFNgo
        // ɁCʂ̃foCXhCõfoCXIuWFNgǗ邽߂ɁC
        // DeviceExtensionɂ炩߂̃o[ݒ肵ĂāC
        // ʂ̃foCXhCõfoCXIuWFNgRs[Ă
        deviceExtension->StackDeviceObject =
            IoAttachDeviceToDeviceStack(deviceObject, 
							PhysicalDeviceObject);
   }

   return ntStatus;
}

// ---------- UnLoad ----------

VOID USB_Unload(IN PDRIVER_OBJECT DriverObject)
{
    USB_KdPrint (("Hello World I'm USB_Unload \n"));
}

// ---------- IRP_MJ_PNP ----------

NTSTATUS
USB_DispatchPnp(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    PIO_STACK_LOCATION  irpStack, nextStack;
    PDEVICE_EXTENSION   deviceExtension;
    NTSTATUS            ntStatus;
    BOOLEAN             DoPassToLowerDeviceDriver = TRUE;

    // ܂I/OX^bNP[Vl
    irpStack = IoGetCurrentIrpStackLocation (Irp);
    deviceExtension = DeviceObject->DeviceExtension;

    // ȏЉɃ}Ci[t@NVǉ
    USB_KdPrint (("Hello World I'm USB_DispatchPnp MinorFunc %02x\n",irpStack->MinorFunction));

    // }Ci[t@NVɏU蕪
    switch (irpStack->MinorFunction) {

    case IRP_MN_START_DEVICE:

        // ɉʃfoCXhCoɏ 
        ntStatus = SendIrpSynchronously(deviceExtension->StackDeviceObject, Irp);
        if (ntStatus == STATUS_SUCCESS) {
            // foCXIuWFNg
            ntStatus = USB_StartDevice(DeviceObject);
        }

        // ʃhCȍ͏IĂ̂
        // ʃfoCXhCȍ͍sȂ
        DoPassToLowerDeviceDriver = FALSE;

        // IRP
        IoCompleteRequest (Irp, IO_NO_INCREMENT);

        break;

    case IRP_MN_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_REMOVE_DEVICE:

        ntStatus = SendIrpSynchronously(deviceExtension->
							StackDeviceObject, Irp);
        if (ntStatus == STATUS_SUCCESS) {
            // foCX폜ꂽꍇ
            // Kvȏ΂ɋLq
        }

        // foCX폜Ă̂ŁC
        // 쐬foCXIuWFNgȂǁCfoCX
        // ̃f[^鏈s

        // C^[tF[Xo^Ăꍇ́C폜
        IoSetDeviceInterfaceState(
            &deviceExtension->InterfaceSymbolicLinkName, 
							FALSE);
        RtlFreeUnicodeString(
            &deviceExtension->InterfaceSymbolicLinkName);

        // ʃfoCXhCofoCXIuWFNg
        // ؂藣āCKw\o^폜
        IoDetachDevice(deviceExtension->StackDeviceObject);

		// RtBM[VfBXNv^̂߂
		// mۂ
		if (deviceExtension->ConfigurationAllDescriptor) 
			ExFreePool(deviceExtension->ConfigurationAllDescriptor);

        // foCXIuWFNg폜
        IoDeleteDevice (DeviceObject);

        // ʃhCȍ͏IĂ̂
        // ʃfoCXhCȍ͍sȂ
        DoPassToLowerDeviceDriver = FALSE;

        break;

    case IRP_MN_QUERY_REMOVE_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_QUERY_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_CANCEL_REMOVE_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_CANCEL_STOP_DEVICE:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    case IRP_MN_SURPRISE_REMOVAL:

        // Ƃ肠Cł͏sȂ
        DoPassToLowerDeviceDriver = TRUE;
        break;

    default:
        // t@NVfoCXhCoȂ̂ŁC
        // ̂ق̃}Ci[R[h̓T|[gȂ 
        // ʂ̃foCXhCoɏC
        DoPassToLowerDeviceDriver = TRUE;
        break;

    } // switch MinorFunction

    if (DoPassToLowerDeviceDriver) {
        // ̊֐ŏȂꍇ́Cׂ
        // ʃfoCXhCoɂ̂܂ܗ
        // ŏĂ炤`ɂ
        IoSkipCurrentIrpStackLocation (Irp);
        ntStatus = IoCallDriver(
            deviceExtension->StackDeviceObject,Irp);
    }

    USB_KdPrint (("Exit USB_DispatchPnp ntStatus %x\n",ntStatus));


    return ntStatus;
}

NTSTATUS
SendIrpSynchronously (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    KEVENT   event;
    NTSTATUS status;

    USB_KdPrint (("I'm SendIrpSynchronously.\n"));

    // ʂ̃foCXhCoÎCxg
    // ҂̂ŁC̃Cxg
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // vOvCȂ̂ŁCI/OX^bN
    // P[VʃfoCXhCoI/OX^bN
    // P[VɃRs[
    IoCopyCurrentIrpStackLocationToNext(Irp);

    // ꍇɌĂяoė~֐o^
    // ̏ꍇ́CIrpCompleteEventSet֐ĂяoāC
    // ŃCxgݒ菈s
    IoSetCompletionRoutine(Irp,
                           IrpCompleteEventSet,
                           &event,
                           TRUE,
                           TRUE,
                           TRUE
                           );

    // ʂ̃foCXhCoĂяoāC
    // vOvC܂sĂ炤
    status = IoCallDriver(DeviceObject, Irp);

    // ʂ̃vOvCI܂ő҂
    // ̃CxǵCʃfoCXhCo
    // IƁCIrpCompleteEventSet֐
    // ɂĔƂ`ɂȂ
    if (status == STATUS_PENDING) {
        KeWaitForSingleObject(&event,
                             Executive,
                             KernelMode,
                             FALSE,
                             NULL
                             );
        status = Irp->IoStatus.Status;
    }

    return status;
}

NTSTATUS
IrpCompleteEventSet (
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp,
    IN PVOID Context
    )
{
    PKEVENT             event = (PKEVENT)Context;

    USB_KdPrint (("I'm IrpCompleteEventSet. \n"));

    // Cxgݒ肵āCCxg҂
    // KeWaitForSingleObject𔲂
    KeSetEvent (event, IO_NO_INCREMENT, FALSE);

    // IĂяȍꍇ͂̃Xe[^XŕԂ
    // ͂u܂ȂvƂoŎg
    return STATUS_MORE_PROCESSING_REQUIRED;
}

NTSTATUS USB_StartDevice(IN PDEVICE_OBJECT DeviceObject)
{
    NTSTATUS ntStatus;
    IN ULONG configurationDescriptorSize;
    PUSB_CONFIGURATION_DESCRIPTOR configurationDescriptor = 
					NULL;
    PDEVICE_EXTENSION deviceExtension;

    USB_KdPrint (("I'm USB_StartDevice.\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    // ----- RtBM[V̑Sf[^m邽߂-----
    // ----- ܂̓RtBM[VfBXNv^݂̂擾 -----

    configurationDescriptorSize = 
					sizeof(USB_CONFIGURATION_DESCRIPTOR);
    configurationDescriptor = ExAllocatePool(
                        NonPagedPool, 
                    configurationDescriptorSize+1);

    ntStatus = USB_GetConfigurationDescriptor(
                    DeviceObject,
                    configurationDescriptorSize,
                    configurationDescriptor
                );
    if ( !NT_SUCCESS(ntStatus) )
        goto USB_StartDeviceExit;

    // ----- ɑSRtBM[Vf[^擾-----

    // RtBM[VfBXNv^wTotalLengthݒ肷
    // ȂC擾RtBM[VfBXNv^
    // DEVICE_EXTENSION\̂ɂ̂ŁCłQƂł
    deviceExtension->TotalConfigDescriptorLength
        = (ULONG)configurationDescriptor->wTotalLength;
    ExFreePool(configurationDescriptor);
    deviceExtension->ConfigurationAllDescriptor
        = ExAllocatePool(
            NonPagedPool,
            deviceExtension->TotalConfigDescriptorLength+1);

    ntStatus = USB_GetConfigurationDescriptor(
                    DeviceObject,
                    deviceExtension->
							TotalConfigDescriptorLength,
                    deviceExtension->ConfigurationAllDescriptor
                );
    if ( !NT_SUCCESS(ntStatus) )
        goto USB_StartDeviceExit;

    USB_KdPrint (("USB_StartDevice Get ConfigAllDescriptor Length = %d\n",
        deviceExtension->TotalConfigDescriptorLength));

    // 擾RtBM[Vf[^Ƃ
    // RtBM[VsāCI
    ntStatus = USB_CreateConfiguration(DeviceObject,
               deviceExtension->ConfigurationAllDescriptor);

USB_StartDeviceExit:

    USB_KdPrint (("Exit USB_StartDevice ntStatus = %x\n",
        ntStatus));

    return ntStatus;
}

NTSTATUS USB_GetConfigurationDescriptor(
    IN PDEVICE_OBJECT DeviceObject,
    IN ULONG configurationDescriptorSize,
    IN PUSB_CONFIGURATION_DESCRIPTOR configurationDescriptor
)
{
    PDEVICE_EXTENSION deviceExtension;
    NTSTATUS ntStatus;
    PURB urb = NULL;

    USB_KdPrint (("I'm USB_GetConfigurationDescriptor.\n"));

    deviceExtension = DeviceObject->DeviceExtension;

    // GET_CONFIGURATION_DESCRIPTOR𔭍s邽߂URBmۂ
    urb = ExAllocatePool(NonPagedPool,
        sizeof(struct _URB_CONTROL_DESCRIPTOR_REQUEST));

    // GET_CONFIGURATION_DESCRIPTOR𔭍s邽߂URB쐬
    UsbBuildGetDescriptorRequest(urb,
        (USHORT) sizeof (struct 
							_URB_CONTROL_DESCRIPTOR_REQUEST),
        USB_CONFIGURATION_DESCRIPTOR_TYPE,
        0,
        0,
        configurationDescriptor,
        NULL,
        configurationDescriptorSize,
        NULL);

    // GET_CONFIGURATION_DESCRIPTOR𔭍s
    ntStatus = USB_CallUSBD(DeviceObject, urb);

    if (urb)
        ExFreePool(urb);

    return ntStatus;
}

NTSTATUS USB_CreateConfiguration(
    IN PDEVICE_OBJECT                DeviceObject,
    IN PUSB_CONFIGURATION_DESCRIPTOR ConfigurationDescriptor
    )
{
#define USB_STORAGE_CLASS_CODE 8
    PDEVICE_EXTENSION           deviceExtension;
    NTSTATUS                    ntStatus;
    PURB                        urb = NULL;
    ULONG                       i, dir;
    PUSB_INTERFACE_DESCRIPTOR   interfaceDescriptor;
    PUSBD_INTERFACE_INFORMATION Interface;
    PUSBD_INTERFACE_LIST_ENTRY 
							interfaceList,topOfInterfaceList;

    USB_KdPrint (("I'm USB_SelectConfiguration.\n"));

    // SELECT_CONFIGURATION
    // ̃foCXhCo̓C^[tF[X
    // 1̃foCXT|[gĂ

    deviceExtension = DeviceObject->DeviceExtension;

    // C^[tF[XiWDMŊǗjXg擾
    // 2mۂĂ̂́C2ڂĨ}[LOƂĎg߂ł

    topOfInterfaceList =interfaceList
        = ExAllocatePool(NonPagedPool,sizeof
							(USBD_INTERFACE_LIST_ENTRY) * 2);
    if(!interfaceList) {
        ntStatus = STATUS_NO_MEMORY;
        goto USB_CreateConfigurationExit;
    }

    // C^[tF[XfBXNv^擾
    interfaceDescriptor =
        USBD_ParseConfigurationDescriptorEx(
            ConfigurationDescriptor,
            ConfigurationDescriptor,
            //T[`ŏ̃RtBM[VfBXNv^
            -1,                        // interface number
            -1,                        // alternate setting
            USB_STORAGE_CLASS_CODE,    // interface class
            -1,                        // interface subclass
            -1 );                      // interface protocol

    // C^[tF[XXgXV
    interfaceList->InterfaceDescriptor = interfaceDescriptor;
    interfaceList->Interface = NULL;

    // C^[tF[X1ŏI
    interfaceList++;
    interfaceList->InterfaceDescriptor = NULL;
    interfaceList->Interface = NULL;

    // SelectConfiguration̂߂URBmۂ
    // Kvȃf[^tH[}bg
    urb = USBD_CreateConfigurationRequestEx(
            ConfigurationDescriptor, topOfInterfaceList);

    // USBD_ParseConfigurationDescriptorExŐݒ肳ꂽ
    // C^[tF[XiWDMǗj擾
    Interface = &urb->UrbSelectConfiguration.Interface;

    // pCv̍ő]TCYCʂɑOɂ炩ߐݒ肵Ă
    // {foCXhCoł́C64KB܂ňCɓ]ł悤ɂ
    for (i = 0; i < Interface->NumberOfPipes; i++) {
        Interface->Pipes[i].MaximumTransferSize = 65536;
    }

    // ZNgRtBM[Vs
    ntStatus = USB_CallUSBD(DeviceObject, urb);

    // ZNgRtBM[V͐H
    if (NT_SUCCESS(ntStatus)) {

        // ̂ŁCUSBf[^\
        USB_KdPrint (("USB_CreateConfiguration Success! ---------- \n"));
        USB_KdPrint (("Class, subclass, protocol 0x%x 0x%x 0x%x\n",
            Interface->Class,
            Interface->SubClass,
            Interface->Protocol));
        for (i = 0; i < Interface->NumberOfPipes; i++) {
            int dir;

            USB_KdPrint (("Endpoint[Addr:%02x] Type %x MaxPacketSize %d \n",
                Interface->Pipes[i].EndpointAddress,
                Interface->Pipes[i].PipeType,
                Interface->Pipes[i].MaximumPacketSize));

            // oNIN/OUT̃pCvCtH[V
            // DEVICE_EXTENSIONɃāCg悤ɂ
            if (Interface->Pipes[i].PipeType == UsbdPipeTypeBulk) {               
					dir = (USBD_PIPE_DIRECTION_IN(&Interface->Pipes[i])) ?
								USBD_TRANSFER_DIRECTION_IN :
									 USBD_TRANSFER_DIRECTION_OUT;
                deviceExtension->BulkPipeInformation[dir] = 
										Interface->Pipes[i];
            }
        }
        USB_KdPrint (("-----------------------------\n"));
    }

    DbgBreakPoint(); 	// ō폜DŃ^[QbgPC~߂ċĂ݂

USB_CreateConfigurationExit:

    // mۂ̉
    if (topOfInterfaceList)
        ExFreePool(topOfInterfaceList);

    if (urb)
        ExFreePool(urb);

    return ntStatus;
}

NTSTATUS USB_CallUSBD(
    IN PDEVICE_OBJECT DeviceObject,
    IN PURB Urb
    )
{
    NTSTATUS ntStatus, status = STATUS_SUCCESS;
    PDEVICE_EXTENSION deviceExtension;
    PIRP irp;
    KEVENT event;
    IO_STATUS_BLOCK ioStatus;
    PIO_STACK_LOCATION nextStack;

    // URBʂ̃foCXhCoɑď˗
    // ICxgő҂
    // deviceExtensionɂUSBoXfoCXhCõIuWFNg
    // ̂ƂiAddDeviceɐݒ肳ĂƉ肷j
    deviceExtension = DeviceObject->DeviceExtension;

    // ʃfoCXhCȍ҂Cxg̏
    KeInitializeEvent(&event, NotificationEvent, FALSE);

    // IOCTL_INTERNAL_USB_SUBMIT_URBvsIRP쐬
    irp = IoBuildDeviceIoControlRequest(
                IOCTL_INTERNAL_USB_SUBMIT_URB,
                deviceExtension->StackDeviceObject,
                NULL,
                0,
                NULL,
                0,
                TRUE, // IRP_MJ_INTERNAL_DEVICE_CONTROLw
                &event,
                &ioStatus);

    // ʃhCoI/OX^bNP[V擾
    nextStack = IoGetNextIrpStackLocation(irp);

    // p[^URBw肷
    nextStack->Parameters.Others.Argument1 = Urb;

    // ʃfoCXhCoioXfoCXhCojɏ˗
    ntStatus = IoCallDriver(deviceExtension->StackDeviceObject,
                            irp);

    // ICxgő҂
    if (ntStatus == STATUS_PENDING)
    {
        ntStatus = KeWaitForSingleObject(
                        &event,
                        Executive,
                        KernelMode,
                        FALSE,
                        NULL);
    }
    else {
        ioStatus.Status = ntStatus;
    }
    ntStatus = ioStatus.Status;

    return ntStatus;
}

// ---------- IRP_MJ_POWER ----------

NTSTATUS
USB_DispatchPower(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP           Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_DispatchPower \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_CREATE ----------

NTSTATUS USB_Create(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_Create \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_CLOSE ----------

NTSTATUS USB_Close(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_Close \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_DEVICE_CONTROL ---------

NTSTATUS USB_ProcessIOCTL(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_ProcessIOCTL \n"));

    return STATUS_UNSUCCESSFUL;
}


// ---------- IRP_MJ_READ -----------
// ---------- IRP_MJ_WRITE ----------

NTSTATUS USB_BulkReadWrite(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    USB_KdPrint (("Hello World I'm USB_BulkReadWrite \n"));

    return STATUS_UNSUCCESSFUL;
}

// EOF
