// UsbStorageTest.cpp: CUsbStorageTest NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "usbtest.h"
#include "UsbStorageTest.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CUsbStorageTest::CUsbStorageTest()
{

}

CUsbStorageTest::~CUsbStorageTest()
{

}

BOOL CUsbStorageTest::Initialize(VOID)
{

    UsbStorageDevice = NULL;
    UsbDevice = new CUsbDevice;

    // USBfoCXhCoI[v
    if (!UsbDevice->UsbDeviceDriverOpen()) {
        return FALSE;
    }

    // foCX̃NX擾
    if (!UsbDevice->GetUsbDeviceClass(&UsbDeviceClass)) {
        return FALSE;
    }


    if ( isThisClassCBI() ) {
        // CBINXȂCCBIStorageDevice쐬
        UsbStorageDevice =
            (CUsbStorageDevice *)(new CCBIStorageDevice);
    }
    else {
        // oNI[NXȂCBulkOnlyStorageDevice쐬
        UsbStorageDevice =
            (CUsbStorageDevice *)(new CBulkOnlyStorageDevice);
    }


    // mۂXg[WfoCX̏
    UsbStorageDevice->DeviceInitialize(UsbDevice);

    // Inquiryf[^擾āCiݒ肷
    if (!GetInquiryData()) {
        return FALSE;
    }

    return TRUE;
}

VOID CUsbStorageTest::Release(VOID)
{
    // USBfoCXhCoN[Y
    UsbDevice->UsbDeviceDriverClose();

    // Xg[WfoCX̉
    if (UsbStorageDevice) {
        if ( isThisClassCBI() )
            delete (CCBIStorageDevice *)UsbStorageDevice;
        else
            delete (CBulkOnlyStorageDevice *)UsbStorageDevice;
    }

    // USBfoCXNX̉
    if (UsbDevice)
        delete UsbDevice;

    // NXƐiNA
    memset(&UsbDeviceClass,0,sizeof(USB_DEVICE_CLASS));
    memset(&ProductName,0,INQUIRY_PRODUCT_NAME_LENGTH);

}

BOOL CUsbStorageTest::AtapiCommandTest
					(ATAPI_REQUEST_PARAMETER *AtapiRequest)
{
    BOOL    isStorageDeviceTestSuccess = TRUE;

// G[̏}N
#define AtapiCommandTestErrorExit() \
    isStorageDeviceTestSuccess = FALSE; goto AtapiCommandTestErrorExit

    // ATAPIR}h𑗐M
    if ( !UsbStorageDevice->SendAtapiRequestPacket(
            (PVOID)AtapiRequest->AtapiRequestPacket,
            AtapiRequest->TransferLength,
            AtapiRequest->isThisRequestRead) )
    {
        AtapiCommandTestErrorExit();
    }

    // f[^΁Cf[^]
    if (AtapiRequest->TransferLength) {
        if ( !UsbStorageDevice->TransferData(
                    AtapiRequest->isThisRequestRead,
                    AtapiRequest->TransferLength,
                    (PVOID)AtapiRequest->DataBuffer,
                    &AtapiRequest->TransferCompleteLength) )
        {
            AtapiCommandTestErrorExit();
        }
    }

AtapiCommandTestErrorExit:


    // Xe[^X̎擾
    if ( !UsbStorageDevice->GetStorageDeviceStatus() )
    {
        isStorageDeviceTestSuccess = FALSE;
    }

    return isStorageDeviceTestSuccess;
}

CHAR* CUsbStorageTest::GetUsbDeviceProductName(VOID)
{
    return ProductName;
}

USB_DEVICE_CLASS* CUsbStorageTest::GetUsbDeviceClass(VOID)
{
    return &UsbDeviceClass;
}

BOOL CUsbStorageTest::GetSenseData(RequestSenseData *SenseDataBuffer)
{
    ATAPI_REQUEST_PARAMETER atapiRequest;

    // ATAPIR}hpPbgNA
    memset(&atapiRequest.AtapiRequestPacket[0], 0,
        ATAPI_COMMAND_REQUEST_LENGTH);

    // ATAPIR}hݒ肷
    // OP CODE = RequestSense
    atapiRequest.AtapiRequestPacket[0] = 0x03;
    // Allocation Length = RequestSense Data
    atapiRequest.AtapiRequestPacket[4] = sizeof(RequestSenseData);
    // f[^̕Cobt@CTCYݒ肷
    atapiRequest.isThisRequestRead = TRUE;
    atapiRequest.DataBuffer = (CHAR *)SenseDataBuffer;
    atapiRequest.TransferLength = sizeof(RequestSenseData);

    // ATAPIR}heXgŏ
    if ( !AtapiCommandTest(&atapiRequest) )
        return FALSE;
    else
        return TRUE;

}

BOOL CUsbStorageTest::GetCapacityData(CapacityData *ReadCapacityData)
{
    ATAPI_REQUEST_PARAMETER atapiRequest;

    // ATAPIR}hpPbgNA
    memset(&atapiRequest.AtapiRequestPacket[0], 0,
        ATAPI_COMMAND_REQUEST_LENGTH);

    // ATAPIR}hݒ肷
    // OP CODE = ReadCapacity
    atapiRequest.AtapiRequestPacket[0] = 0x25;

    // f[^̕ƃobt@CTCYݒ肷
    atapiRequest.isThisRequestRead = TRUE;
    atapiRequest.DataBuffer = (CHAR *)ReadCapacityData;
    atapiRequest.TransferLength = sizeof(CapacityData);

    // ATAPIR}heXgŏ
    if ( !AtapiCommandTest(&atapiRequest) )
        return FALSE;
    else
        return TRUE;
}

BOOL CUsbStorageTest::GetInquiryData(VOID)
{
    CHAR    InquiryDataBuffer[36];
    ATAPI_REQUEST_PARAMETER atapiRequest;

    // ATAPIR}hpPbgNA

    memset(&atapiRequest.AtapiRequestPacket[0], 0,
        ATAPI_COMMAND_REQUEST_LENGTH);

    // ATAPIR}hݒ
    // OP CODE = Inquiry
    atapiRequest.AtapiRequestPacket[0] = 0x12;
    // Allocate Length = 36;
    atapiRequest.AtapiRequestPacket[4] = 36;

    // f[^̕Cobt@CTCYݒ肷

    atapiRequest.isThisRequestRead = TRUE;
    atapiRequest.DataBuffer = (CHAR *)InquiryDataBuffer;
    atapiRequest.TransferLength = 36;

    // ATAPIR}heXgŏ
    if ( !AtapiCommandTest(&atapiRequest) )
        return FALSE;

    // v_Ng𒊏oĊi[
    // v_Ng̓ItZbg1616oCgɂȂi\2-21QƁj
    memcpy(ProductName,&InquiryDataBuffer[16],16);

    return TRUE;
}

ULONG CUsbStorageTest::IsDeviceHighSpeed(VOID)
{
    // foCXx̃`FbN
    return UsbDevice->IsDeviceHighSpeed();
}

BOOL CUsbStorageTest::isThisClassCBI(VOID)

{
    // vgR`FbNCCB/CBIXg[W 
    // foCXۂ`FbN
    if (UsbDeviceClass.InterfaceProtocol != 
					BULK_ONLY_DEVICE_PROTOCOL)
        return TRUE;
    else
        return FALSE;
}

